
import qt
execfile(qt.reload_current_setup)
####
print 'reload all measurement parameters and calibrations...'
# from measurement.scripts.lt2b_scripts.setup import msmt_params as mcfg
from measurement.scripts.lt2b_scripts.setup import msmt_params as mcfg

reload(mcfg)
qt.exp_params=mcfg.cfg

import time

import numpy as np
import msvcrt
import time
import sys
import matplotlib.pyplot as plt

from scan import scan
import hdf5_data as h5
from analysis.lib.tools import toolbox as tb
import analysis.scripts.Fabrication.Display_scan2d as ds
import analysis.scripts.Fabrication.testCV2 as testcv
import measurement.lib.measurement2.measurement as m2
#import analysis.scripts.Fabrication.neural_image_recognition as nir
import pandas as pd

import cv2
import os
import shutil
import multiprocessing

from measurement.lib.config import optimiz0rs as optcfg
reload(optcfg)


from measurement.scripts.autoNVsearch.basic import esr_NV_search # for performing ESR scans 

from measurement.scripts.autoNVsearch.basic import optimize_SN # for optimising in the z-direction, contains the optimize_z() function that we use in this script
from measurement.scripts.autoNVsearch.basic import TLC_2 as TLC # to control the tunable laser controller and its input #XXX changed to 2. keep onlu if works
from measurement.instruments.optimiz0r import optimiz0r as NV_search_optimizer # contains functions for optimising in x and y
from measurement.scripts.autoNVsearch.basic import rabi_NV_search # for implementing Rabi measurements
from measurement.scripts.autoNVsearch.basic import DESR_NV_search # for implementing DESR measurements
from analysis.scripts.laser_scan import analyse_single_trans # for analysing a linescan
# from measurement.scripts.lt3_scripts.laser_scan import laser_scan_auto_freq_new_red_green as laser_scan 
from measurement.scripts.autoNVsearch.basic import laser_scan_NV_search as laser_scan 
from analysis.lib.fitting import fit, common,esr, esr_peak


from measurement.scripts.autoNVsearch.basic import autoNVsearch_functions
from measurement.scripts.autoNVsearch.basic import calibrate_drift
from analysis.lib.tools import plot
from measurement.scripts.rt2_scripts.lightfield_remote import LightField_Remote
import analysis.scripts.cavity.spectrometer_analysis as sa
import measurement.scripts.autoNVsearch.basic.SnV_search_functions as snvf
import analysis.lib.autoNV.peakfinder as pkf


# from Pushetta.pushetta import Pushetta # for pushnotifications

# API_KEY = "9b84a294c8c80829bf383f91c2405f2c1896788f" # API key for sending push notifications, channel name is 'autoNVsearch'
# p = Pushetta(API_KEY)

reload(snvf)
reload(optimize_SN)
reload(TLC)
reload(testcv)
reload(ds)
reload(esr_NV_search) #XXXXXXXXXremove if 2 works
reload(rabi_NV_search)
reload(DESR_NV_search)
reload(analyse_single_trans)
reload(autoNVsearch_functions)
reload(calibrate_drift)
# reload(qt)
reload(plot)
reload(m2)
reload(laser_scan)
reload(pkf)




mos = qt.instruments['master_of_space']
opt1d_counts = qt.instruments['opt1d_counts']


# newfocus = qt.instruments.create('newfocus', 'Newfocus_TLB6700_v2') #moved this to create_instruments!!!!!!!




class NV_search(m2.Measurement):

    def __init__(self,name,save=True):
        """
        This constructor sets the initial value of stopper to false, a boolean used to abort the script
        """
        m2.Measurement.__init__(self, name,save=save)
        self.stopper = False

        #instead, use parameters for each blob again? 
        self.params.from_dict(qt.exp_params['protocols']['Auto_NV_search'])#should not be done here, but in a script that calls this function. keep here for now.
        self.GreenAOM = qt.instruments['GreenAOM']
        self.physical_adwin = qt.instruments['physical_adwin']
        self.counters = qt.instruments['counters']

        self.opt_counter_number = 2

        try:
            self.msquared = qt.instruments['MSquared']
        except:
            print 'No MSquared found'
        #XXXX I think life would be better if the 'autoNVsearch_functions are in NV_search class.'
        # XXX Shouldn't we make a measurement NV search that does all the blob things only, 
        # XXX Than the 'execute_NV_search' could be in a separate class.
        # XXX all the attributes that are now self.m."something" could then become self."something"

    def show_stopper(self):
        #this function initiates the stopper in case of q key event
        print '---------------------------'            
        print 'Press q to stop measurement'
        print '---------------------------'
        t0 =  time.time()
        qt.msleep(3)

        if (msvcrt.kbhit() and (msvcrt.getch() == 'q')):
            self.stopper = True
        else: 
            self.stopper = False

    def get_pipe_var(self,var, var_name, var_step, step):
        """
        201807 MJD

        This function gets pipe variables (variables that are output of a certain step and input in any of the following steps),
        from the auto_NV dictionary if particular steps are shut down.

        Input:
            var (float)       : The pipe variable of interest
            var (str)         : The name of the pipe variable
            var_step (str)    : The step that is responsible for the output of this variable
            step (str)        : The current step

        Output:
            var : The variable, either from the dictionary or the one given as input.
        """
        if self.m.params['do_' + str(var_step)] == True:
            return var
        elif self.m.params['do_' + str(var_step)] == False:
            return self.m.params[str(step) + '_' + str(var_name)]
        # elif self.m.params[str(var_step) + '_overwrite'] == True:
        #     return self.m.params[str(step) + '_' + str(var_name)]
        else:
            raise Exception('Invalid var_step')


    def get_pipe_var_from_dict(self,var, var_name, var_step, params_dict):
        """
        201807 MJD - adapted 201808 SvD

        This function gets pipe variables (variables that are output of a certain step and input in any of the following steps),
        from the auto_NV dictionary if particular steps are shut down.

        Input:
            var (float)       : The pipe variable of interest
            var (str)         : The name of the pipe variable
            var_step (str)    : The step that is responsible for the output of this variable
            params_dict (str)        : The dictionary from which the data should be extracted

        Output:
            var : The variable, either from the dictionary or the one given as input.
        """
        if self.m.params['do_' + str(var_step)] == True:
            return var
        elif self.m.params['do_' + str(var_step)] == False:
            return params_dict[str(var_name)]
        # elif self.m.params[str(var_step) + '_overwrite'] == True:
        #     return self.m.params[str(step) + '_' + str(var_name)]
        else:
            raise Exception('Invalid var_step')

    def get_range(self,x_o,y_o,zoom,scan_size=2):
        n_of_pix = int(zoom/scan_size)
        coord_x = np.ones(n_of_pix)
        coord_y = np.ones(n_of_pix)

        for i in xrange(np.size(coord_x)):
            coord_x[i] = x_c-zoom/2+scan_size/2+i*scan_size

        for i in xrange(np.size(coord_y)):
            coord_y[i] = y_c-zoom/2+scan_size/2+i*scan_size
        return coord_x,coord_y


        #this function uses blob recognition functions found in the analysis folder in order to find the coordinates of potential NVs
        #this is currently replaced by manual selection of blobs
    

    def scan_area(self,z,search_range,x_scan,y_scan): 
        """
        Code to find blobs automatically. 
        Not used ATM
        """

        #z_range=[-1.5]
        #x_range,y_range=self.get_range(x_o,y_o,zoom)

        oldest_folder = None
        blobs_list = []
        xs_blobs = np.array([])
        ys_blobs = np.array([])
        blobs_counter = 0
    
        ip = testcv.Image_processor()
        ip.config(search_range)

        img_buf_total = []

        timestamp2D, folder2D = autoNVsearch_functions.zoom(x_scan,y_scan,z,green_power = self.params['green_scan_power'])

        timestamp2,folder = tb.latest_data(contains='scan2d', older_than = None,return_timestamp=True)
        d = ds.DisplayScanFlim(folder)
        d.get_data()
        d.split_image(folder,x_scan,y_scan,save=True,colormap='gist_earth',search_range=search_range)

        for filename in os.listdir(folder):
            if 'x_c' in filename:
                cropped_image = ip.crop_image(folder, filename)
                x_blobs,y_blobs = ip.find_blobs(folder,filename,cropped_image,search_range,z)

                # xs_blobs = np.append(xs_blobs,x_blobs)
                # ys_blobs= np.append(ys_blobs,y_blobs)
                
                blobs_counter += len(x_blobs)

                xy_blobs = np.append([x_blobs],[y_blobs],axis=0)
                xy_blobs = np.transpose(xy_blobs)
                blobs_list.append(xy_blobs)

        # blobs_list=np.append([xs_blobs],[ys_blobs],axis=0)
        self.blobs_list = blobs_list
        self.blobs_counter = blobs_counter
        return blobs_list,blobs_counter


    def single_optimization(self, xpos, ypos, zpos, reps = 1, name = ''): 
        # we have the option here to reset the x,y,z. This is used only in the first optimization step.
        mos.set_x(xpos)
        qt.msleep(0.1) # in seconds
        mos.set_y(ypos)
        qt.msleep(0.1) # in seconds

        #No repeatable positioning if not done like following way - 
        # XXX SvD. I think waiting long enough rather than doing it 3 timees is the trick.
        # XXX it was removed in the autoNVserach_functions. do we still want it?
        for i in range(3):
            mos.set_z(zpos)
            qt.msleep(2)# in seconds

        success = self.single_dim_optimization(dims = ['y','x'], reps = reps,name = name)
        # for i in range(reps):
        #     success_first = optimiz0r.optimize(cycles=1, dims=['y','x'])

        return success


    def z_optimization(self,name=''):
        """
        This function performs a z-optimization of the type specificed in self.m.params['z_opt_type']. 
        options are 'cts_max', which does a regular Gaussian optimization
        or 'SN' which does a SN optimizer.
        """
        success = True

        if self.m.params['z_opt_type'] == 'SN':
            '''
            The SN optimizer.
            '''
            z_opt, z_opt_SN, z_opt_xfit, z_opt_yfit, x_SN, y_SN = optimize_SN.optimize_z(filepath=self.datafolder, green_power = self.m.params['green_opt_power'], nr_pts = 8, z_range = 0.8)
            #z_opt, z_opt_SN, z_opt_xfit, z_opt_yfit = optimize_SN.optimize_z(filepath=self.datafolder, green_power = 150e-6, nr_pts = 8, z_range = 0.8)

            qt.msleep(1)
            #z-optimisation data is saved in h5-file
            # XXX this group should only be made if it doesnt exists yet
            z_opt_group = h5.DataGroup('z_optimisation_SN_'+name, self.m.h5data, base=self.m.h5base)
            z_opt_group.add('zs',data=z_opt)
            z_opt_group.add('SN',data=z_opt_SN)
            z_opt_group.add('zp',data=z_opt_xfit)
            z_opt_group.add('zpfit',data=z_opt_yfit)
            z_opt_group.add('x_SN',data=x_SN)
            z_opt_group.add('y_SN',data=y_SN)

        elif self.m.params['z_opt_type'] == 'max_cts': #enable using a 'regular' z optimisation
            '''
            If the z_opt_type is max_cts, use the regular z_optimizer, based on single_dim_optimization. 
            All the saving is done in single_dim_optimization at the moment.
            '''            
            success_z =self.single_dim_optimization(dims= ['z'], reps=2, name = name)

        else:
            print 'Please provide a valid z-optimization type! valid are z_opt_type = max_cts or SN '
        
        success =self.single_dim_optimization(dims = ['x', 'y'] , reps=1, name = name)

        return success

    def single_dim_optimization(self,dims=['z'],reps = 1, name = ''):
        '''
        This function does the optimisation in a single dimension, 
        and saves the obtained data. 
        The optimal position that is fit is saved in the xyz-tracker (if success).
        The raw data is saved in groups called 'dim'_optimization_Gauss (always).
        The raw data is saved with a number 'dim'_opt_counter that increments with every optimization
        as well as a name that can be added as a **kw (default is empty). 
        '''
        success = True

        self.GreenAOM.set_power(self.m.params['green_opt_power'])
        for i in range(reps):
            for dim in dims:
                # the function below is a (bit ugly) way to INCREMENT the 'dim'_opt_counter.
                setattr(self.m, '%s_opt_counter'%(dim), getattr(self.m,'%s_opt_counter'%(dim))+1 )

                # performing the actual MEASUREMENT
                success_d,pos,cts,opt_value = opt1d_counts.run(dimension=dim, scan_length=1., nr_of_points=31, pixel_time=50, return_success_data=True, gaussian_fit=True)#, counter=2 )
                qt.msleep(1.0) # in seconds

                success = (success and success_d)
                
                # SAVING the data
                if success_d:
                    # update the internal position attribute
                    setattr(self.m,'%s_pos'%(dim), opt_value)
                    # update the XYZ-tracker with NEW POSITION
                    getattr(self.m,'track_%s_data'%(dim)).resize((getattr(self.m,'track_%s_data'%(dim)).shape[0]+1),axis=0)
                    getattr(self.m,'track_%s_data'%(dim))[-1:] = [opt_value,time.time()]

                # saving the RAW DATA to a new group (name "opt_counter_value"_'name')
                # within the "dim'_optimisation_Gauss group.
                if '%s_optimisation_Gauss'%(dim) not in self.m.h5basegroup:
                    opt_group = self.m.h5basegroup.create_group('%s_optimisation_Gauss'%(dim))
                else:
                    opt_group = self.m.h5basegroup['%s_optimisation_Gauss'%(dim)]

                this_opt_group = opt_group.create_group('%d_%s'%(getattr(self.m,'%s_opt_counter'%(dim)),name))
                this_opt_group.create_dataset('pos',data=pos)
                this_opt_group.create_dataset('cts',data=cts)

                # If the Optimiser fails, also do not continue with the others.
                if not success:
                    self.GreenAOM.turn_off()
                    return success
                if (msvcrt.kbhit() and (msvcrt.getch() == 'q')):
                    'stopping optimizer'
                    break
            if (msvcrt.kbhit() and (msvcrt.getch() == 'q')):
                'stopping optimizer remaining reps'
                break

                
        self.GreenAOM.turn_off()

        return success




    def find_peaks(self, redfreq, redcounts): 

        ''' 
        This function returns the frequencies of the first and second maximum (excluding some area of the first to prevent double peak detection)
        '''
        # we create a new numpy array of the redcounts. 
        # the peaks and their surrounding (in a range 2*exclude_peakrange_freq) will be set to nan as we go
        redcounts_array = np.array(redcounts)

        if len(redcounts_array) == 0:
            return []

        first_max_index = np.nanargmax(redcounts_array)
    
        a = redfreq[first_max_index]
        min_freq_index_a = np.argmin(abs(redfreq-(a-self.params['exclude_peakrange_freq'])))
        max_freq_index_a = np.argmin(abs(redfreq-(a+self.params['exclude_peakrange_freq'])))

        # #check if limits are not outside the range
        # if (first_max_index-self.params['broadscan_exclude_peakrange_bins'])>0:
        #     first_min_lim_index =  first_max_index-self.params['broadscan_exclude_peakrange_bins']
        # else:
        #     first_min_lim_index = 0
        # if (first_max_index+self.params['broadscan_exclude_peakrange_bins']) < len(redfreq):
        #     first_max_lim_index = first_max_index+self.params['broadscan_exclude_peakrange_bins']
        # else:
        #     first_max_lim_index = -1

        redcounts_array[min_freq_index_a:max_freq_index_a] = np.nan

        # redcounts_without_max1 = np.concatenate((redcounts[0:min_freq_index_a],redcounts[max_freq_index_a:-1])) # exclude first peak

        print 'peak 1', a, 'of cts:', redcounts[first_max_index]
        print 'ignoring peaks in a range ',redfreq[min_freq_index_a],'to',redfreq[max_freq_index_a]

        found_max_2 = False

        mean_noise = np.nanmean(redcounts_array)

        if not np.isnan(mean_noise): #the mean_noise is nan only if redcounts_array consists of nan's only by now! If not, we continue to look for peak 2
            sec_max_index = np.nanargmax(redcounts_array)

            #no longer needed with the new nan strategy
            # if sec_max_index > (min_freq_index_a):
            #     sec_max_index = sec_max_index + 2*self.params['broadscan_exclude_peakrange_bins']
            #     if sec_max_index >= (len(redfreq)-1):
            #         sec_max_index = -1

            b = redfreq[sec_max_index]

            min_freq_index_b = np.argmin(abs(redfreq-(b-self.params['exclude_peakrange_freq'])))
            max_freq_index_b = np.argmin(abs(redfreq-(b+self.params['exclude_peakrange_freq'])))

            #check if limits are not outside the range
            # if (sec_max_index-self.params['broadscan_exclude_peakrange_bins'])>0:
            #     sec_min_lim_index =  sec_max_index-self.params['broadscan_exclude_peakrange_bins']
            # else:
            #     sec_min_lim_index = 0
            # if (sec_max_index+self.params['broadscan_exclude_peakrange_bins']) < len(redcounts_without_max1):
            #     sec_max_lim_index = sec_max_index+self.params['broadscan_exclude_peakrange_bins']
            # else:
            #     sec_max_lim_index= -1

             ### added 201607 MJD
            # redcounts_without_max_1_and_2 = np.concatenate((redcounts_without_max1[0:sec_min_lim_index],redcounts_without_max1[sec_max_lim_index:-1])) # exclude first and second peak
            redcounts_array[min_freq_index_b:max_freq_index_b] = np.nan


            found_max_2 = True
            # redcounts_without_maxima = redcounts_without_max_1_and_2

            print 'peak 2', b, ' of cts:', redcounts[sec_max_index] 
            print 'ignoring peaks in a range ',redfreq[min_freq_index_b],'to',redfreq[max_freq_index_b]
       
        mean_noise = np.nanmean(redcounts_array)
        std_noise = np.nanstd(redcounts_array)
    
        if np.isnan(mean_noise):  #in case the whole array is eaten by the peak and their ranges!
            mean_noise = np.mean(redcounts)
            std_noise = np.std(redcounts)

        print 'noise:', mean_noise, '+-',std_noise   

        peak_freqs = []

        if (redcounts[first_max_index] > (self.params['broadscan_noisefloor_factor']*std_noise+mean_noise)): # new criterion: has to be x*std away from mean. #New criterion: number of counts must exceed 30 times mean of data with first two maxima substracted 
            print 'peak at ',a,' GHZ is added'
            peak_freqs.append(a)
        if found_max_2 and (redcounts[sec_max_index] > (self.params['broadscan_noisefloor_factor']*std_noise+mean_noise)):
            peak_freqs.append(b)
            print 'peak at ',b,' GHZ is added'

        return peak_freqs

    def wrap_up_blob(self,i,j):
        '''
        Append all the successes that will later be put in a summarising subgroup of the h5-file.
        This had to be added as a separate function to allow for breaking out of the loop
        '''
        # XXX reduce to single lines by appending (int(self.XY_success ) etc; see below)
        # if (self.XY_success):
        #     self.XY_successes.append(1)
        # else: 
        #     self.XY_successes.append(0)

        # if (self.continue_optimization):
        #     self.Gaussian1D_successes.append(1)
        # else: 
        #     self.Gaussian1D_successes.append(0)

        # if (self.Z_success):
        #     self.Z_successes.append(1)
        # else: 
        #     self.Z_successes.append(0)


        self.XY_successes.append(int(self.XY_success))
        self.Gaussian1D_successes.append(int(self.continue_optimization))
        self.Z_successes.append(int(self.Z_success))
        self.Redscansuccesses.append(int(self.Redscansuccess))
        self.Broadscansuccesses.append(int(self.Broadscansuccess))

        #succesful candidates are granted the status of NV (based on ESR)
        if (self.ESRsuccess):
            self.ESR_successes.append(1)
            if self.m.params['do_optimizor']:  
                self.nv_coordinates.append(([self.m.x_pos,self.m.y_pos,self.m.z_pos]))
            else: ## why not also self.m.x_pos??? etc
                self.nv_coordinates.append(([self.blobs_list[j][i][0], self.blobs_list[j][i][1],  self.blobs_list[j][i][2]]))
        else: 
            self.ESR_successes.append(0)

        #XXXX decide what to take as reference: reference NV or different final position - init position per blob?

        self.translational_correction_x.append(self.translational_correction[0])
        self.translational_correction_y.append(self.translational_correction[1])
        self.translational_correction_z.append(self.translational_correction[2])


        # if (rabi_success):
        #     rabi_successes.append(1)
        # else:
        #     rabi_successes.append(0)

        '''
        Below, we ensure that the blobfolders (individual measurement folders) are stored in the parent folder 'autoNVsearch'.

        '''
        #Since we cannot choose the directory of the measurement folders, we change the name and put it inside the parent folder "autoNVsearch"
        newdir = os.path.join(self.datafolder, os.path.basename(self.m.datafolder))
        #The folder name is given the lastest coordinates of the blob 201809 MJD not anymore, see below

        ## 201809 MJD the newfoldername should always be given the initial 'clicked' position of the blob.
        ## this is how the analysis code is now written up
        ## The positional drift information is still stored in the blob hdf5 file and thus accessible.
        # if self.m.params['do_optimizor']:
            # newfoldername = 'blob_%d_%d_x_%.2f_y_%.2f_z_%.2f'%(j,i, self.m.x_pos, self.m.y_pos, self.m.z_pos)
        # else:
        newfoldername = 'blob_%d_%d_x_%.2f_y_%.2f_z_%.2f'%(j,i, self.blobs_list[j][i][0], self.blobs_list[j][i][1],  self.blobs_list[j][i][2])
        newdirnewfoldername = os.path.join(self.datafolder, newfoldername)

        #add NEW filepath to h5-file
        self.params['blob_%d_%d_filepath'%(j,i)] = os.path.join(newdirnewfoldername, os.path.basename(self.m.datafolder)) + '.hdf5'
        
        print 'Done with blob: saving all the measurement parameters.'
        self.m.finish()
        qt.msleep(1)

        #moving and renaming
        try:
            shutil.move(self.m.datafolder, self.datafolder)
        except WindowsError:
            print 'shuttling data file failed!'
            pass
        qt.msleep(4)

        try:
            os.rename(newdir, newdirnewfoldername)
        except:
            print 'rename file failed'


    def wrap_up_z_plane(self,j):
        if j==0:
            grp = h5.DataGroup('Successes', self.h5data, base=self.h5base)

        '''
        Save a summary of all types of successes and add them to different groups in the h5-file.
        '''
        name0 = 'XY_successes_in_plane_%d'%j
        data0 = self.XY_successes

        name1 = 'Gaussian1D_successes_in_plane_%d'%j
        data1 = self.Gaussian1D_successes

        name2 = 'Z_successes_in_plane_%d'%j
        data2 = self.Z_successes
        
        name3 = 'ESR_successes_in_plane_%d'%j
        data3 = self.ESR_successes

        name4 = 'translational_correction_x' 
        data4 = self.translational_correction_x
        
        name5 = 'translational_correction_y'
        data5 = self.translational_correction_y

        name6 = 'translational_correction_z'
        data6 = self.translational_correction_z

        
        if data0 != None:
            grp.add(name0,data=data0)

        if data1 != None:
            grp.add(name1,data=data1)

        if data2 != None:
            grp.add(name2,data=data2)

        if data3 != None:
            grp.add(name3,data=data3)

        if data4 != None:
            grp.add(name4, data = data4)

        if data5 != None:
            grp.add(name5, data = data5)

        if data6 != None:
            grp.add(name6, data = data6)

        name7 = 'NV_coordinates'  
        data7 = self.nv_coordinates
        grp.add(name7,data=data7)

        name8 = 'ref_coordinates'
        data8 = self.ref_coors
        grp.add(name8,data=data8)       

        # try:
        #     message = 'No. of NVs at depth z=%d: '%self.blobs_list[j][0][2] + str(sum(self.ESR_successes)) + ' / ' + str(len(self.ESR_successes)) + '\n' + 'No. of lines detected: ' + str(sum(self.no_of_peaks))
        #     p.pushMessage("autoNVsearch", message)

        # except:
        #     pass


    def execute_characterisation(self,blobs_list, printstate = True):

        '''
########################################### I N I T I A L I S A T I O N ###########################################
        '''

        magnet_positioners = False          

        if magnet_positioners:
                #save magnet positions
            self.params['SMC100_axis1_pos'] = SMC100.get_position_um(channel=1)
            self.params['SMC100_axis2_pos'] = SMC100.get_position_um(channel=2)
            self.params['SMC100_axis3_pos'] = SMC100.get_position_um(channel=3)
        self.blobs_list = blobs_list
        self.counters.set_is_running(False) #turn off counters. during green-red counter measurements is otherwise goes on sometimes! 
        #Creates an instance of the RABI measurement class
        r = rabi_NV_search.auto_rabi_on_NV()

        #Creates an instance of the DESR measurement class
        d = DESR_NV_search.auto_desr_on_NV()

        # set the initial drift correction coordinates and ref_coor (standard [0,0,0])
        self.translational_correction = self.params['translational_correction']
        self.ref_coors = self.params['ref_coors_init']

        # choose whether you want to set a reference NV manually
        set_ref_manually = self.params['set_ref_manually']
        if set_ref_manually:
            # Set x,y,z values as reference
            self.ref_coors = self.params['ref_coordinates']
        
        #Loop throug the z-planes of the blob list
        for j in range(len(self.blobs_list)):


            #Intitialize empyt coordiante array around which we will do esr measurement later
            esr_to_check_coordinates = []
            self.nv_coordinates = []

            self.XY_successes = []
            self.Gaussian1D_successes = []
            self.Z_successes = []
            self.ESR_successes = []
            self.rabi_successes = [] # XXX NOT USED ATM
            self.Redscansuccesses = []
            self.Broadscansuccesses = []

            # transational drift correction in x,y,z
            self.translational_correction_x = []
            self.translational_correction_y = []
            self.translational_correction_z = []
            # Counter for the number of successful ESR scans
            cur_nr_esr_succes = 0

            ESR_fit_result_frq = float #XX remove
            max_peak_fit = float
            rabi_freq = float
            peak_freqs = [] #XX remove

            self.no_of_peaks = []
            
            print 20*'*'
            print 'going to next z-plane '
            print 'stop now to stop all blob-measurements in this z-plane'
            print 20*'*'
            self.show_stopper()
            if self.stopper:
                self.wrap_up_z_plane(j)
                break


            #Loop throug the length of the blob list
            for i in xrange(len(self.blobs_list[j])):
                print 20*'*'
                print 'going to next blob'
                print 20*'*'

                # Set the initial value of pipe vars for the optimizor # XXXX shouldnt these just be initialised as False always?
                self.XY_success = False#self.params['XY_success'] 
                self.Z_success = False#self.params['Z_success'] 
                self.continue_optimization = False#self.params['continue_optimization']

                # Set the initial value of the boolean pipe vars
                self.ESRsuccess = False#self.params['esr_success'] #esr
                self.fineESRsuccess = False

                self.Redscansuccess = False#self.params['narrow_success'] #narrow
                self.Broadscansuccess = False
                self.Spectrumpeaksuccess = False

                rabi_success = False #self.params['rabi_success']

                #Get the x and y coordinates around wich we want to use the optimizor
                x_pos = self.blobs_list[j][i][0] + self.translational_correction[0]
                y_pos = self.blobs_list[j][i][1] + self.translational_correction[1]
                z_pos = self.blobs_list[j][i][2] + self.translational_correction[2]

                '''
                Here we create an instance of the measurement-class.
                This will automatically assign a filepath to the h5-file, which can be extracted as "m.h5datapath". This path is saved in m_all.params.
                '''
                self.m = m2.Measurement(name='blob_%d_%d_x_%.2f_y_%.2f_z_%.2f'%(j,i,self.blobs_list[j][i][0],self.blobs_list[j][i][1],self.blobs_list[j][i][2]))  
                self.m.blob_name = 'blob_%d_%d'%(j,i)

                self.m.params.from_dict(qt.exp_params['protocols']['Auto_NV_search']) 
                
                # XXXX we should turn this self.m into a separate class perhaps, that has the things below (and above) in its init.
                # XXXX some of the functions that are now in 'self' can then be part of this class, such as 
                # optimizers, getting of pipe vars.

                # initialise the x,y and z position as attributed of the measurement. these will update as we go after each optimisation.
                self.m.x_pos = x_pos
                self.m.y_pos = y_pos
                self.m.z_pos = z_pos
                # counters that counts the number of optimizations performed in each direction
                self.m.x_opt_counter = 0
                self.m.y_opt_counter = 0 
                self.m.z_opt_counter = 0 

                #create datagroups for tracking the x,y positions
                self.m.track_xyz_group = self.m.h5basegroup.create_group('xyz_tracker')#h5.DataGroup('xyz_tracker', m.h5data,base=m.h5base)
                time0=time.time()

                self.m.track_x_data = self.m.track_xyz_group.create_dataset('x',data=[[self.m.x_pos,time0]], maxshape = (None,2)) #create a dataset that can contain x-positions and the time at which these were measured
                self.m.track_y_data = self.m.track_xyz_group.create_dataset('y',data=[[self.m.y_pos,time0]],maxshape = (None,2)) #create a dataset that can contain x-positions and the time at which these were measured
                self.m.track_z_data = self.m.track_xyz_group.create_dataset('z',data=[[self.m.z_pos,time0]],maxshape = (None,2)) #create a dataset that can contain x-positions and the time at which these were measured

                ########################################### initialize CONTINUE CONDITIONS #####################################
                continue_msmts = True # turns into False if a crucial step fails
                continue_broadscan = False #turns into True if ESR performed and broadscan_ignore_esr_success is True
                continue_resonant = self.m.params['resonant_ro_ignore_laserscan_success']# turns into True if the laserscans succesful, or if self.m.params['resonant_ro_ignore_laserscan_success'] 

                # let the game begin!
                '''
    ########################################### X , Y - O P T I M I S A T I O N ###########################################
                '''   
                # Only if you want to perform the optimizor step...
                if self.m.params['do_optimizor']:  #XXXX shall we aim to make it more modular, having a separate function for all the bits?
  
                    print 40*'*'
                    print 'starting x-y optimisation'
                    print 40*'*'
                    self.show_stopper()
                    if self.stopper:
                        self.wrap_up_blob(i,j)
                        break

                    self.GreenAOM.set_power(self.m.params['green_opt_power'])

                    #Prints the x,y coordinates if needed (based on printstate)
                    if printstate:
                        print 'x_search=', x_pos
                        print 'y_search=', y_pos
                    
                    #counts the number of x,y optimisations needed
                    opt_times = 0

                    #First optimisation test (2 times)
                    self.XY_success = self.single_optimization(x_pos, y_pos, z_pos, reps=1, name = 'first_try_xy_opt')
                    opt_times += 2

                    #If the opimizer succeeded, then we get the gaussianness and if in certain bounds then we continue the optimization 
                    if (self.XY_success):
                        #If gausianness is OK then go to continue optimization. The total number of optimizations is 2.
                        self.continue_optimization = autoNVsearch_functions.check_gaussian_fit()

                        #otherwise one more time
                        if self.continue_optimization == False:
                            #after this line, the total number of optimisations is 3.
                            self.XY_success = self.single_optimization(x_pos, y_pos, z_pos, reps=1, name = 'second_try_xy_opt_failcheck')
                            opt_times += 1

                            if (self.XY_success):
                                #Try gaussian fit once more
                                self.continue_optimization = autoNVsearch_functions.check_gaussian_fit()

                    #if the optimizer didnt succeed then try again
                    else:
                        #try one more time for success. After this line, the total number of optimisations is 4.
                        self.XY_success = self.single_optimization(x_pos, y_pos, z_pos, reps=2, name = 'second_try_xy_opt_failopt')
                        opt_times += 2                    
                        #same gaussian check
                        if (self.XY_success):
                            #again check gaussian fit
                            self.continue_optimization = autoNVsearch_functions.check_gaussian_fit()

                    #print output in case of failure
                    print "success of XY (success first) is:", self.XY_success
                    print "the number of x,y optimisations is:", opt_times

                    if self.XY_success == False:
                        if printstate:
                            print "The NV at position", x_pos, y_pos, z_pos, "failed our optimizor test and was not checked for Gaussian fit (failed after 4 x,y-optimisations)"


                    '''
    ########################################### Z - O P T I M I S A T I O N ###########################################
                    '''
                    #continuing optimization if gaussian is ok
                    if self.continue_optimization:
                        print 40*'*'
                        print 'starting z optimisation'
                        print 40*'*'
                        self.show_stopper()
                        if self.stopper:
                            self.wrap_up_blob(i,j)
                            break
                        self.Z_success = self.z_optimization(name = 'first_z_opt')

                    else:
                        print "We are sorry to inform you that we will not continue ESR on this blob due to poor Gaussian fit of the 1D linescan (fit fail after 2, 3 or 4 x,y-optimisations)."

                    #save meta-data
                    self.m.params['success_xy_opt'] = self.XY_success 
                    self.m.params['number_of_xy_opt'] = opt_times
                    self.m.params['success_gaussian'] = self.continue_optimization
                    self.m.params['success_z_opt'] = self.Z_success 

                    #save the latest coordinates in the local h5-file
                    self.m.params['x'] = mos.get_x()  #won't be necessary with the xyz tracker. can choose to save init & final though?
                    self.m.params['y'] = mos.get_y()
                    self.m.params['z'] = mos.get_z()

                    ###################################### CONTINUE CONDITION ###########################################################
                    continue_msmts = self.Z_success

                #In case we do not want to do an optimizor step, we still need to make sure we set the autoNVsearch to the next NV position!
                else:
                    mos.move_to_xyz_pos(['x', 'y', 'z'], [x_pos, y_pos, z_pos])


                #store the latest coordinates acquired from last optimizer (which might have changed the coordinates)
                cur_x_pos = mos.get_x()#m.params['x']
                cur_y_pos = mos.get_y()#m.params['y']
                cur_z_pos =  mos.get_z()#m.params['z']

                print 'candidate_coordinate_x=', cur_x_pos
                print 'candidate_coordinate_y=', cur_y_pos
                print 'candidate_coordinate_z=', cur_z_pos

                #all blobs ready to be checked for ESR are stored in here:
                esr_to_check_coordinates.append(([cur_x_pos,cur_y_pos,cur_z_pos]))


                '''
########################################## Spectrometer#######################################
                '''

                if (continue_msmts and self.m.params['do_spectrometer']):
                    fmirror = qt.instruments['SpectroPath'] #Shoudl actually be SpectroPath




                    self.m.params.from_dict(qt.exp_params['protocols']['Auto_NV_search']['Spectrometer'])

                    if self.m.params['filtered_scan']:
                        bpfilter = qt.instruments['bpfilter']
                        bpfilter.flip_down()
                    fmirror.flip_up()
                    print 40*'*'
                    print 'starting spectrometer'
                    print 40*'*'
                    self.show_stopper()
                    if self.stopper:
                        self.wrap_up_blob(i,j)
                        break

                    # if (self.m.params['do_narrow'] and self.m.params['laser_type'] == 'MSquared'): #Moved after the narrowscan step
                    #     self.msquared.set_wl(585)
                    #     time.sleep(2)
                    self.GreenAOM.set_power(self.m.params['green_spectr_power'])
                    #self.GreenAOM.turn_on()

                    filename = 'Spectr'
                    lightfield_remote_dir = 'Lightfield'
                    lightfield = LightField_Remote(host = "131.180.34.220")
                    # try:
                    #     lightfield.close_lightfield()
                    # except:
                    #     print 'Already closed'
                    # print "Opening LightField"
                    # lightfield.open_lightfield()
                    # time.sleep(5)

                    # if self.m.params['grating_type'] == 'fine':
                    #     lightfield.load_experiment('SnV_fine_grating')
                    # else:
                    #     lightfield.load_experiment('SnV_std_grating')

                    # lightfield.set_temperature(-75)
                    # lightfield.set_exposure_time(self.m.params['exposure_time'])
                    # lightfield.set_export(True)

                    try:
                        lightfield.open_lightfield()
                        'Opening Lightfield'
                    except:
                        print 'Already open'
                    time.sleep(5)
                    if self.m.params['grating_type'] == 'fine':
                        lightfield.load_experiment('SnV_fine_grating')
                    else:
                        lightfield.load_experiment('SnV_std_grating')
                    lightfield.set_temperature(-75)
                    lightfield.set_exposure_time(self.m.params['exposure_time'])
                    lightfield.set_export(True)

                    #Cleaning up after the last measurement
                    print "Cleanining data folder"
                    files = lightfield.get_saved_files(lightfield_remote_dir)
                    if len(files)>0:
                        for file_name in files:
                            lightfield.delete_file(lightfield_remote_dir,file_name)

                    print "Taking data"         
                    lightfield.save_file()
                    time.sleep(self.m.params['exposure_time']/1000+5)

                    #Get files back onto local computer
                    print "Retrieving data"
                    files = lightfield.get_saved_files(lightfield_remote_dir)

                    for file_name in files:
                        string = lightfield.retrieve_saved_file(lightfield_remote_dir, file_name)
                        data = string.split("\n")
                        with open(self.m.datafolder+'\\'+file_name,'wb') as local_file:
                            for line in data:
                                local_file.write(line)
                                local_file.write('\n')
                        lightfield.delete_file(lightfield_remote_dir,file_name)

                        #Save spectrum png file
                        if True:
                            c_light = 299792458

                            dat = pd.read_csv(self.m.datafolder+'\\'+file_name, usecols = [2, 4, 5])

                            cts = np.array(dat['Intensity'])
                            pixel = np.array(dat['Column'])
                            wl = np.array(dat['Wavelength'])

                            if np.isnan(wl[0]):
                                # Fine grating - no offset measured up to now
                                spec_f_offset =  0.04446 - 0.004 #0.05246 #0.04446 #corrected by 0.004 on 25/06/2020
                                wl = pixel * 0.01636 + 608.9 ## Calibration linear fit for fine grating (centered at 620nm) - taken on 9/4/2020 
                                frequencies = c_light/(wl*1e-9)/1e12 - spec_f_offset
                                wl = c_light/(frequencies*1e12)*1e9

                            else:
                                #STD grating - Offset measured by referencing it to the MSquared
                                spec_f_offset =  0.263351 #THz - Offset between spectrometer broad grating and MSquared. Measured Jan.2020
                                frequencies = c_light/(wl*1e-9)/1e12 - spec_f_offset
                                wl = c_light/(frequencies*1e12)*1e9


                            #Fit spectrum to find peaks
                            if self.m.params['use_wl_range']:
                                idxmin = np.argmin(np.abs(wl - self.m.params['wl_range_min']))
                                idxmax = np.argmin(np.abs(wl - self.m.params['wl_range_max']))
                            else:
                                idxmin = 0
                                idxmax = len(wl)

                            # peak_wl, peak_cts, peak_idx = pkf.find_spectrum_peaks(wl[idxmin:idxmax], cts[idxmin:idxmax], num_of_peaks = self.m.params['num_of_peaks'])
                            # peak_wl, peak_chisq, peak_fitf = pkf.fit_spectrum_peaks(wl[idxmin:idxmax], cts[idxmin:idxmax], peak_idx)
                            # if len(peak_wl) > 0:
                            #     peak_freq = c_light/(np.array(peak_wl)*1e-9)/1e9 - self.m.params['wavemeter_reference_freq'] #Peak frequency in GHz with respect to wavemeter reference frequency
                            # else:
                            #     print 'Could not fit any peak'
                            #     peak_freq = []

                            # SnV peak fitting
                            SnVsearch = True
                            peak_wl, peak_cts, peak_idx = pkf.find_spectrum_peaks(wl[idxmin:idxmax], cts[idxmin:idxmax], num_of_peaks = self.m.params['num_of_peaks'])

                            # if SnVsearch:
                            #     if len(peak_wl < 3):
                            #         fitresult = snvf.fit_two_SnV_peaks(wl, cts)
                            #         print "Trying to fit a single SnV"
                            #     elif len(peak_wl < 5):
                            #         fitresult = snvf.fit_double_SnV(wl, cts)
                            #         print "Trying to fit two SnVs"
                            #     if fitresult[0]:
                            #         print "Successful fit"
                            #         peak_wl = np.array(fitresult[1:])
                            #         peak_freq = c_light/(peak_wl*1e-9)/1e9 - self.m.params['wavemeter_reference_freq'] #Peak frequency in GHz with respect to wavemeter reference frequency

                            #     else:
                            #         print "Could not fit SnVs"
                            #         peak_wl = [] 
                            #         peak_freq = [] 
            
                            try:
                                peak_wl2, peak_chisq, peak_fitf = pkf.fit_spectrum_peaks(wl[idxmin:idxmax], cts[idxmin:idxmax], peak_idx)
                            except:
                                print 'fitting gone wrong'
                                peak_wl2 = peak_wl
                            if len(peak_wl2) > 0:
                                peak_freq = c_light/(np.array(peak_wl2)*1e-9)/1e9 - 484000 #Peak frequency in GHz with respect to wavemeter reference frequency
                            else:
                                print 'Could not fit any peak'
                                peak_freq = []




                            self.m.peak_freqs = peak_freq
                            self.m.params['peaks_freqs'] = self.m.peak_freqs
                            print 'The peaks are:', self.m.peak_freqs
                            print len(self.m.peak_freqs)

                            ### XXXXXX todo: make this an optional feature.
                            if len(self.m.peak_freqs)>0:
                                self.Spectrumpeaksuccess = True

                            spec_image, spec_ax = plt.subplots()
                            #spec_ax.plot(wl, cts)
                            spec_ax.plot(wl[1:len(wl)], cts[1:len(cts)])
                            spec_ax.set_xlim(610, 630)
                            if self.m.params['print_peaks']:
                                idxs = [np.argmin(np.abs(wl - x)) for x in peak_wl2]
                                peak_cts = cts[idxs]
                                spec_ax.plot(peak_wl2, peak_cts, 'o')

                            plt.savefig(self.m.datafolder+ '\\' + file_name[:-4] + '.png')
                            plt.cla()
                            plt.close()

                            ## Save data in HDF5 file

                            Spectrometer_group = self.m.h5basegroup.create_group('Spectrometer')
                            Spectrometer_group.create_dataset('wavelength', data = wl)
                            Spectrometer_group.create_dataset('frequency', data = frequencies)
                            Spectrometer_group.create_dataset('counts', data = cts)
                            Spectrometer_group.create_dataset('peaks', data = peak_freq)

                            self.m.h5data.flush()


                            #or
                            # Line_group = h5.DataGroup('1dLinescan', self.m.h5data,base=self.m.h5base)
                            # Line_group.add('y_points',data=points)
                            # Line_group.add('counts',data=counts)

                    if self.m.params['filtered_scan']:
                        bpfilter.flip_up()
                    
                    fmirror.flip_down()

                '''
########################################### E S R ###########################################
                '''
                #if z optimization ok, go for esr!
                # if ((self.Z_success or self.m.params['do_optimizor']==False) and self.m.params['do_esr']):

                if (continue_msmts and self.m.params['do_esr']):
                    print 40*'*'
                    print 'starting ESR'
                    print 40*'*'
                    self.show_stopper()
                    if self.stopper:
                        self.wrap_up_blob(i,j)
                        break


                    #filename in case of filepath=None in run function
                    name = '_ESR_coarse_'+'x='+str(cur_x_pos)[:4]+'_y='+str(cur_y_pos)[:4]+'_z='+str(cur_z_pos)[:4]
                    '''
                    Here is where we run the ESR script, which saves its own file separately ONLY IF no filepath is specified!
                    In this case, the name will be used as the png filename. The specified directory is where the h5-file is saved.
                    This will ensure that the png image of ESR will be saved together with the h5-file that ALSO contains the ESR data,
                    since it is returned by e.run(..) and saved as a separate group in h5 (see following).
                    '''                 
                    ## reps was 50

                    e2 = esr_NV_search.esr_on_blob(name = name, save=False, h5basegroup=self.m.h5basegroup, h5datafolder = self.m.datafolder)  #XXX make this self.e later #XXX initialize anew for each esr
                    e2.params.from_dict(qt.exp_params['protocols']['Auto_NV_search']['ESR'])
                    e2.params['time']=time.time()
                    self.ESRsuccess, ESRfreq, ESRcounts, self.translational_correction = e2.run(translational_correction = self.translational_correction, 
                        ref_coordinates = self.ref_coors, cur_nr_esr_succes = cur_nr_esr_succes)


                    self.m.ESR_fit_result_frq = e2.ESR_fit_result_frq # apparently, fit_result is a dictionary and contains a lot of stuff
                    print 'Central freq of ESR is:', self.m.ESR_fit_result_frq

                    # esr_fit_freq output is adusted to be at freq_list[np.argmin(counts)] if this freq is within esr_widt_factor*esr_fit_width \
                    # from the esr_fit_freq. For best contrast on following rabi msmts.
                    # ESR_fit_result_x0 = e2.fit_result.get('p0')[-2]()

                    # ESRsuccess, ESRfreq, ESRcounts, translational_correction = e.run(name=name, filepath=self.m.datafolder, \
                    #     freq_range= self.m.params['esr_freq_range'], reps=self.m.params['esr_reps'],\
                    #     center_freq = self.m.params['esr_center_freq'], mw_power = self.m.params['esr_mw_power'] , \
                    #     drift_calibrate = self.m.params['esr_drift_cal'], translational_correction = translational_correction, \
                    #     ref_coordinates = ref_coors, cur_nr_esr_succes = cur_nr_esr_succes)#2.8937)

                    # ESR_fit_result_frq = e.fit_result.get('p0')[-1]() # apparently, fit_result is a dictionary and contains a lot of stuff
                    # print 'Central freq of ESR is:', ESR_fit_result_frq





                    # '''
                    # Here we create an ESR group containing the data
                    # '''
                    # ESR_group = h5.DataGroup('ESRdata', self.m.h5data,base=self.m.h5base)
                    # ESR_group.add('freq',data=ESRfreq)
                    # ESR_group.add('counts',data=ESRcounts)

                    print 'The h5 data is saved in', self.m.datafolder #we have to be careful here to use datafolder rather than filepath, which also contains the filename!
                    print 'The ESR images are saved in', self.m.h5data.filepath() #e.filepath should be the same as m.datafolder, unless we havent specified the filepath when creating e.run
                    e2.finish()
                    self.m.h5data.flush() #flush the data in the datafile, such that it is also available if the code crashes after this.


                    ###################################### CONTINUE CONDITION ###########################################################
                    continue_msmts = self.ESRsuccess# XXXX change parameter name to broadscan_ignore_esr_success
                    if self.params['broadscan_ignore_esr_success']:
                        continue_broadscan = True


                self.m.params['success_ESR'] = self.ESRsuccess


                # Set a counter for the ESR success (used such that )
                if self.ESRsuccess:
                    cur_nr_esr_succes += 1


                if self.m.params['do_optimizor']: ### XXXXX shouldnt we just save this directly after the Gaussian fit?

                    #We also want to save the latest liescan in a plot. Be careful, te 0 in the get data needs
                    #generalization and there might be a better way to get this data
                    points = linescan_counts.get_points()[0]
                    counts = linescan_counts.get_data('countrates')[0]
                    plt.figure(1)
                    plt.plot(points, counts)
                    
                    #data of 1Dlinescan is saved in h5 file
                    Line_group = h5.DataGroup('1dLinescan', self.m.h5data,base=self.m.h5base)
                    Line_group.add('y_points',data=points)
                    Line_group.add('counts',data=counts)

                    '''
                    The 1d linescan image is saved in the SAME FOLDER AS ESR images: e.filepath
                    '''
                    plt.savefig(os.path.join(self.m.datafolder, '_counter.png'))
                    plt.close(1)


                """
                ########################################### P E R F O R M I N G  A  D R I F T  C A L I B R A T I O N ############################################
                """
                if (cur_nr_esr_succes == 1 and not set_ref_manually and self.m.params['do_translation_correction']):

                    # Store the current x,y,z values as reference
                    self.ref_coors = [cur_x_pos, cur_y_pos, cur_z_pos]

                ########################################### PREFORMING A DRIFT CALIBRATION ############################################
                ########################################### PREFORMING A DRIFT CALIBRATION ############################################

                if ((bool(cur_nr_esr_succes) or set_ref_manually) and self.m.params['do_translation_correction']):
                    print 'Performing translational correction...'
                    self.translational_correction = calibrate_drift.calibrate_drift([self.translational_correction[0],self.translational_correction[1],self.translational_correction[2]], \
                    self.ref_coors, printstate = printstate)
                    print 'Translational_correction: ', self.translational_correction
                ########################################### PREFORMING A DRIFT CALIBRATION ############################################
                ########################################### PREFORMING A DRIFT CALIBRATION ############################################
                ########################################### PREFORMING A DRIFT CALIBRATION ############################################



                '''
########################################### R E D / G R E E N - L I N E S C A N ###########################################
                '''
                #if ((self.ESRsuccess or (self.m.params['broadscan_ignore_esr_success'] and self.Z_success)) and self.m.params['do_broadscan']):
                if ((continue_msmts or continue_broadscan) and self.m.params['do_broadscan']):
                    print 40*'*'
                    print 'starting broad laserscan'
                    print 40*'*'
                    self.show_stopper()
                    if self.stopper:
                        self.wrap_up_blob(i,j)
                        break

                    ''' 
                    # Only if ESR resulted in a resonance, we continue with the red/green linescan
                    # The following function is called from TLC.py and in turn triggers repeated_red_scans in laser_scan_auto_freq_new_red_green.py
                    # The arguments specify the full scan range (start_, stop_freq) and width of each scan (i.e. scan_range)
                    # The function return an array containing each individual linescan that is saved in the standard way.
                    # We therefore need to manually read the data from these .dat files and append it to the h5-file.
                    # The reason that we let the function return the filepath is that the data is buried very deeply inside initiate_broad_scan.
                    # Since it is many function layers deep, it is easier to extract the data from the .dat file that we can easily access
                    # via the returned filepath. This also allows us to move the linescan folders (containing individual data and plot)
                    # into the autoNVsearch parent folder in a subdirectory called 'RED_SCANS' that is located in each blob folder. 

                    In addition, the initiate_scan function allows for both broad and narrow scans, depending on the specified width.
                    For widths smaller than 20 GHz, the coarse frequency of the TLC (tunable laser controller) will not be changed -->
                    this allows for a more accurate measurement of individual lines.

                    '''
                    '''
                    # We first initialise the GreenRedScan instance. 
                    # It is initialised with the blob's group and folder, such that it can save data in the right directory
                    # The parameters loaded into it are initialized from the msmt_params file
                    # except for the MW_freq: that one is, if it exists, gotten from the fit of the ESR
                    # The laserscan instance is given along with the TLC, such that it can call the start of 'repeated_scans'.  
                    '''



                    '''
                    ########################################### optimize position  ###########################################
                    '''
                    if self.m.params['do_optimizor_broadscan']:
                        success =self.single_dim_optimization(dims = ['x', 'y'] , reps=1, name= 'before_broadscan')
                        success = self.z_optimization(name = 'before_broadscan')


                    broad_greenred_parentfolder = os.path.join(self.m.datafolder,'BROAD_RED_SCANS')
                    if not os.path.exists(broad_greenred_parentfolder):
                        os.makedirs(broad_greenred_parentfolder)


                    ### FROM HERE ----------------------------------------------------------------------------------------------------------
                    #Here creates GreenRedScan which is the one that actually performs the single scans

                    if self.m.params['laser_type'] == 'TLC':

                        Laserscan_name = 'BroadLaserscan_GreenRed'
                        ls = laser_scan.GreenRedScan(name = Laserscan_name, save = False, h5basegroup=self.m.h5basegroup, h5datafolder = self.m.datafolder,qtdatafolder = broad_greenred_parentfolder)
                        ls.params.from_dict(qt.exp_params['protocols']['Auto_NV_search']['Broad_Laserscan'])
                        ls.params['time']=time.time()

                        ### Checking whether the pipe var ESR_fit_result_frq, should be obtained from the params dict, or as output from the esr step. 
                        # ls.params['MW_freq'] = self.get_pipe_var_from_dict(self.m.ESR_fit_result_frq, 'MW_freq', 'esr', ls.params) #XXX could here just check is ESR_fit_result exists instead.
                        if hasattr(self.m,'ESR_fit_result_frq'):
                            ls.params['MW_freq'] = self.m.ESR_fit_result_frq
                        print 'MW freq is set to', ls.params['MW_freq']


                        #Here calls initiate_scan that actually splits the freq range in mode-hop-free steps and calls GreenRedScan to perform a scan per each step. It returns a list of file paths, one for each step-scan

                        filepaths = TLC.initiate_scan(ls=ls, start_freq = ls.params['broadscan_start_freq'], stop_freq = ls.params['broadscan_stop_freq']) 

                    if self.m.params['laser_type'] == 'MSquared':

                        ls = laser_scan.M2GreenRedScan(name = Laserscan_name, save = False, h5basegroup=self.m.h5basegroup, h5datafolder = self.m.datafolder,qtdatafolder = broad_greenred_parentfolder,  start_freq = ls.params['broadscan_start_freq'], stop_freq = ls.params['broadscan_stop_freq'])
                        
                        ### Checking whether the pipe var ESR_fit_result_frq, should be obtained from the params dict, or as output from the esr step. 
                        # ls.params['MW_freq'] = self.get_pipe_var_from_dict(self.m.ESR_fit_result_frq, 'MW_freq', 'esr', ls.params) #XXX could here just check is ESR_fit_result exists instead.
                        if hasattr(self.m,'ESR_fit_result_frq'):
                            ls.params['MW_freq'] = self.m.ESR_fit_result_frq
                        print 'MW freq is set to', ls.params['MW_freq']

                        filepaths = ls.repeated_scans(name = Laserscan_name)


                    ls.finish()
               
                    self.m.h5data.flush() #flush the data in the datafile, such that it is also available if the code crashes after this.

                    ''' 
                    For each linescan in the full range, we load the filepath of the .dat file and load the data as reddata.
                    In the RED_SCANS folder, we also save a png image
                    of the plot that contains all data together. This bundle of data is finally saved as a separate h5-datagroup.
                    '''

                    #DATA ANALYSIS ------------------------------------WE WANT THIS PART------------------------------------------------------------------------
                    #Here it loads all the step-scans (freq and counts), creates and normalise an histogram to see how many cts per frequency

                    redfreq = []
                    redcounts = []
                    # red_parentfolder = os.path.join(self.m.datafolder,Laserscan_name)

                    for M in filepaths: 
                        print M
                        reddata = np.loadtxt(M) # reads one of the linescan files                        
                        redfreq.extend(reddata[:,1]) # adds a new list of frequencies to the existing array
                        redcounts.extend(reddata[:,2]) # adds a new list of counts to the existing

                    # bin the data
                    nr_bins = int((max(redfreq)-min(redfreq))/ls.params['binsize_postprocessing'])+1 #this is necessary, because in practice the steps are not freq_step.  31-1-2020 How does this work for M**2 Terascan?
                    print nr_bins
                    bins = np.linspace(min(redfreq),max(redfreq),nr_bins)
                    _h_points,_b_points, = np.histogram(redfreq, weights=np.ones(len(redfreq)), bins=bins) #histogram for normalisation
                    _h,_b = np.histogram(redfreq, weights=redcounts, bins=bins) #histogram that adds up the counts per bin
                    binned_redfreq=_b[:-1]+np.diff(_b) #freqpoints should be the centre of the bin
                    binned_redcounts = _h/_h_points #we have to normalise again to get the appropriate rate!
                    # remove bins where there were no points inside (they turned out as 'nan' counts)
                    binned_redfreq = binned_redfreq[~np.isnan(binned_redcounts)]
                    binned_redcounts = binned_redcounts[~np.isnan(binned_redcounts)]

                    #Here just prepares the plots

                    plt.figure(2)
                    plt.plot(redfreq, redcounts)
                    plt.title(os.path.split(self.m.datafolder)[-1])
                    plt.savefig(os.path.join(self.m.datafolder, 'BROAD_RED_SCAN_OVERVIEW.png'))
                    plt.close(2)

                    plt.figure(3)
                    plt.plot(binned_redfreq, binned_redcounts)
                    plt.title(os.path.split(self.m.datafolder)[-1])
                    plt.savefig(os.path.join(self.m.datafolder, 'BROAD_RED_SCAN_OVERVIEW_BINNED.png'))
                    plt.close(3)

                    if Laserscan_name in self.m.h5basegroup:
                        Laserscan_group = self.m.h5basegroup[Laserscan_name]
                    else:
                        Laserscan_group = self.m.h5basegroup.create_group(Laserscan_name)
                    Laserscan_group.create_dataset('freq', data=redfreq)
                    Laserscan_group.create_dataset('counts', data=redcounts)
                    Laserscan_group.create_dataset('freq_binned', data=binned_redfreq)
                    Laserscan_group.create_dataset('counts_binned', data=binned_redcounts)





                    # peak_freqs = self.find_peaks(redfreq, redcounts)
                    # print peak_freqs
                    self.m.peak_freqs = self.find_peaks(binned_redfreq, binned_redcounts)
                    self.m.params['peaks_freqs'] = self.m.peak_freqs
                    print self.m.peak_freqs

                    ### XXXXXX todo: make this an optional feature.
                    if len(self.m.peak_freqs)>0:
                        self.Broadscansuccess = True

                        g_a1 = np.mean(binned_redcounts)
                        g_A1 = np.max(binned_redcounts) - np.min(binned_redcounts)
                        g_x01 = self.m.peak_freqs[0]
                        g_sigma1 = 1.0 ## In GHz hardcoded in, if you find a better way please implement MJD

                        # plt.clf()
                        # plt.close()
                        # fig, ax = plt.subplots()
                        # p0, fitfunc, fitfunc_str = common.fit_gauss(g_a1,g_A1,g_x01,g_sigma1)

                        if len(self.m.peak_freqs)<2.0:
                            fit_result=fit.fit1d(binned_redfreq,binned_redcounts,common.fit_gauss, g_a1, g_A1, g_x01, g_sigma1,ret=True,
                                                fixed=[],do_print=True)
                        else:
                            g_x02 = self.m.peak_freqs[1]
                            g_A2 = np.max(binned_redcounts) - np.min(binned_redcounts)
                            g_sigma2 = 1.0 ### In GHz
                            fit_result = fit.fit1d(binned_redfreq,binned_redcounts\
                                                     ,common.fit_2gauss,g_a1, g_A1, g_x01, g_sigma1, g_A2, g_x02, g_sigma2,ret=True,
                                                fixed=[],do_print=True)
                        plot.plot_fit1d(fit_result, np.linspace(binned_redfreq[0],binned_redfreq[-1],201), plot_data=True, add_text = False, print_info = False)
                        plt.savefig(os.path.join(self.m.datafolder, 'BROAD_RED_SCAN_OVERVIEW_BINNED_fit.png'))
                        plt.close()
                        
                        fit_params = open(os.path.join(self.m.datafolder,'BROAD_RED_SCANS/fit_params.txt'),'w')
                        fit_params.write(str(fit_result)) 
                        fit_params.close()


                        try: 

                            if fit_result['success']:

                                ## Here we grab the the width of the first and second peak
                                params_names = [x for x in fit_result['params_dict']]
                                index = np.argmax(['sigma' in x for x in params_names])
                                self.m.broad_scan_highestpeak_width = fit_result['params_dict'][params_names[index]]
                                if self.m.broad_scan_highestpeak_width > ls.params['broadscan_width_tolerance']:
                                    ## turn broadscansuccess to False, to prevent red-green fine ESR on a wide peak.
                                    self.Broadscansuccess = False
                                if len(self.m.peak_freqs)>1.0:
                                    self.m.broad_scan_secondpeak_width = fit_result['params_dict'][params_names[index+1]]   
                                    # in case we have two peaks, we use the width of the widest peak to select whether we are going to do relatively broad or narrow red scans     
                                    self.m.broadscan_peak_width = max([(2*np.sqrt(2))*self.m.broad_scan_secondpeak_width, (2*np.sqrt(2))*self.m.broad_scan_highestpeak_width])
                                else:
                                    self.m.broadscan_peak_width = (2*np.sqrt(2))*self.m.broad_scan_highestpeak_width




                        except:

                            self.Broadscansuccess = True

                    try:
                        del ls
                    except:
                        pass

                    ###################################### CONTINUE CONDITION ###########################################################
                    # if Redscansucces, or if we are to ignore the laserscan success for doing resonant readout, we set continue_resonant = True
                    # if this is False, we will continue_offresonant (no explicit condition). This means: doing a fine ESR with green RO. 
                    if self.Broadscansuccess:
                        continue_resonant = True
                        continue_msmts = True

                    self.m.params['success_broadscan'] = self.Broadscansuccess


                    ########################################### PREFORMING A DRIFT CALIBRATION ############################################

                    if ((bool(cur_nr_esr_succes) or set_ref_manually) and self.m.params['do_translation_correction']):
                        print 'Performing translational correction...'
                        self.translational_correction = calibrate_drift.calibrate_drift([self.translational_correction[0],self.translational_correction[1],self.translational_correction[2]], \
                        self.ref_coors, printstate = printstate)
                        print 'translational_correction', self.translational_correction
                    ########################################### PREFORMING A DRIFT CALIBRATION ############################################
                    


                if (continue_msmts and (self.m.params['do_narrowmw'] or self.m.params['do_narrow'])):
                    ### Checking whether the pipe var peak_freqs, should be obtained from the params dict, or as output from the broadscan step.


                    if self.m.params['shutter_ZPL']:
                        print 'Flipping ShutterZPL down'
                        shutter = qt.instruments['ShutterZPL']
                        time.sleep(1)
                        shutter.flip_up()
                        time.sleep(2)

                    for peak_index, peak in enumerate(self.m.peak_freqs):

                        self.no_of_peaks.append(1)

                        narrow_folder_reference = []
                        ''' 
                        Create a separate folder for each peak:
                        '''
                        narrow_parentfoldername = 'PEAK_' + str(peak)
                        narrow_parentfolder = os.path.join(self.m.datafolder, narrow_parentfoldername) # here we create a new directory inside autoNVsearch inside each blob folder to save all the linescan folders
                    
                        if not os.path.exists(narrow_parentfolder):
                                os.makedirs(narrow_parentfolder)
                        else:
                            print 'The "PEAK" main folder could not be created.'


                        '''
########################################### N A R R O W - R E D - G R E E N - L I N E S C A N ###########################################
                        '''



                        # Only if we want to perform a narrow linescan (red-green)
                        if self.m.params['do_narrow']:
                            print 40*'*'
                            print 'starting narrow red green scan at peak ', peak_index,' :  ',peak
                            print 40*'*'
                            self.show_stopper()
                            if self.stopper:
                                self.wrap_up_blob(i,j)
                                break

                            '''
                            -----------------------Here we initiate the narrow scan around the peak found in the broad scan-----------------------
                            '''
                            '''

                            The Scan is based on a GreenRedScan, and loads the parameters in the Narrow_Laserscan_GreenRed dictionary. 
                            The MW frequency - if applied  (standard would be not) - is based on the ESR, if that is done
                            The frequency range is determined by the peak frequency and the narrow_freq_range.

                            We save the .dat file in a parent folder (narrow_redgreen_parentfolder) that sits within the PEAK's folder(narrow_parentfolder)
                            The data is also saved in the hdf5 file, in a subfolder with the name 'Laserscan_name'
                            '''

                            '''
                            ########################################### optimize position  ###########################################
                            '''
                            if self.m.params['do_optimizor_narrowscan']:
                                success =self.single_dim_optimization(dims = ['x', 'y'] , reps=1, name = 'before_narrowscan_greenred')
                                success = self.z_optimization(name = 'before_narrowscan_greenred')

                 

                            narrow_redgreen_parentfolder = os.path.join(narrow_parentfolder,'REPEATED_RED_GREEN')
                            if not os.path.exists(narrow_redgreen_parentfolder):
                                os.makedirs(narrow_redgreen_parentfolder)

                            Laserscan_name = 'LaserScan_Narrow_peak_%d'%(peak_index)

                            if self.m.params['laser_type'] == 'TLC':
                                ls = laser_scan.GreenRedScan(name = Laserscan_name, save = False, h5basegroup=self.m.h5basegroup, h5datafolder = self.m.datafolder, qtdatafolder = narrow_redgreen_parentfolder)
                                ls.params.from_dict(qt.exp_params['protocols']['Auto_NV_search']['Narrow_Laserscan_GreenRed'])
                            
                            elif self.m.params['laser_type'] == 'MSquared':
                                if self.m.params['scan_type'] == 'resonator':
                                    ls = laser_scan.M2ResonatorScan(name = Laserscan_name, save = False, h5basegroup=self.m.h5basegroup, h5datafolder = self.m.datafolder, qtdatafolder = narrow_redgreen_parentfolder)
                                    self.msquared.set_relative_freq(peak, reference_freq = self.m.params['wavemeter_reference_freq'])
                                    time.sleep(20)

                                else:
                                    ls = laser_scan.M2GreenRedScan(name = Laserscan_name, save = False, h5basegroup=self.m.h5basegroup, h5datafolder = self.m.datafolder, qtdatafolder = narrow_redgreen_parentfolder)
                                ls.params.from_dict(qt.exp_params['protocols']['Auto_NV_search']['Narrow_Laserscan_MSquared'])

                            
                            ls.params['time']=time.time()
                            if not hasattr(self.m, 'peak_freqs'):
                                self.m.peak_freqs = self.m.params['narrow_peak_freqs']


                            # ### determining the scanning range
                            # if hasattr(self.m, 'broadscan_peak_width'):
                            #     # broadest_peak = max([(2*np.sqrt(2))*self.m.broad_scan_secondpeak_width, (2*np.sqrt(2))*self.m.broad_scan_highestpeak_width])
                            #     if self.m.broadscan_peak_width > ls.params['peak_width_threshold']:
                            #         ls.params['narrow_freq_range'] = ls.params['above_threshold_range']
                            #         ls.params['frequency_step'] = ls.params['above_threshold_frequency_step']
                            #     else:
                            #         ls.params['narrow_freq_range'] = ls.params['below_threshold_range']
                            #         ls.params['frequency_step'] = ls.params['below_threshold_frequency_step']

                            # elif hasattr(self.m, 'broad_scan_highestpeak_width'):
                            #     if (2*np.sqrt(2))*self.m.broad_scan_highestpeak_width > ls.params['peak_width_threshold']:
                            #         ls.params['narrow_freq_range'] = ls.params['above_threshold_range']
                            #     else:
                            #         ls.params['narrow_freq_range'] = ls.params['below_threshold_range']
                            # else: # XXXX use narrow_freq_range standard value.
                            #     ls.params['narrow_freq_range'] = ls.params['below_threshold_range']


                            ### Checking whether the pipe var ESR_fit_result_frq, should be obtained from the params dict, or as output from the esr step. 
                            if hasattr(self.m,'ESR_fit_result_frq'):
                                ls.params['MW_freq'] = self.m.ESR_fit_result_frq
                            ### finding the start and stop frequencies from the peak and the narrow_freq_range.



                            if self.m.params['laser_type'] == 'TLC':
                                ls.params['narrowscan_start_freq'] = peak - ls.params['narrow_freq_range']/2.
                                ls.params['narrowscan_stop_freq'] = peak + ls.params['narrow_freq_range']/2.
                                filepath = TLC.initiate_scan(ls=ls, start_freq = ls.params['narrowscan_start_freq'], stop_freq = ls.params['narrowscan_stop_freq']) 
                            
                            elif self.m.params['laser_type'] == 'MSquared':
                                if self.m.params['scan_type'] == 'resonator':
                                    # ls.params['scan_step'] = self.m.params['scan_step']
                                    # ls.params['scan_size'] = self.m.params['scan_size']
                                    print 'Performing resonator scan'
                                else:
                                    ls.params['start_freq'] = peak - ls.params['narrow_freq_range']/2.
                                    ls.params['stop_freq'] = peak + ls.params['narrow_freq_range']/2.
                                    print 'scanning from %.2f to %.2f' %(ls.params['start_freq'], ls.params['stop_freq'])
                                # ls.params['terascan_rate'] = self.m.params['terascan_rate']
                                # ls.params['terascan_units'] = self.m.params['terascan_units']
                                if self.m.params['use_ND']:
                                    ND_filter = qt.instruments['NDfilter']
                                    ND_filter.flip_down()

                                filepath = ls.repeated_scans()

                                if self.m.params['use_ND']:
                                    ND_filter.flip_up()



                            ls.finish()
                            self.m.h5data.flush() #flush the data in the datafile, such that it is also available if the code crashes after this.
                            del ls

                            self.m.params['blob_%d_%d_peak_index_%d_narrow_scan_dir'%(j,i,peak_index)] = narrow_redgreen_parentfolder


                            '''
                            The peak is fit immediately 
                            This can be used to find the frequencies for a resonant Rabi or (D)ESR.
                            The check whether the peak is suitable for resonant excitation (i.e. if succesful) is only done if no other peak is found yet
                            This sets automatically the ideal order: highest peak first, and narrow mw scan before narrow green red scan.
                            '''
                            success_fit, peak_fit, peak_fit_err, gauss_width  = analyse_single_trans.get_freq_from_gauss(filepath, ret='success')
                            
                            if not self.Redscansuccess:# check the success only if no success is found yet. 
                                if success_fit: 
                                    if peak_fit_err < self.m.params['narrowmw_peak_fit_error'] and gauss_width < self.m.params['narrowmw_peak_width']: ## 
                                        max_peak_fit = peak_fit
                                        self.Redscansuccess = True





                        '''
########################################### N A R R O W - R E D - M W - L I N E S C A N ###########################################
                        '''
                        if self.m.params['do_narrowmw']:
                            print 40*'*'
                            print 'starting narrow mw scan at peak ', peak_index,' :  ',peak
                            print 40*'*'
                            self.show_stopper()
                            if self.stopper:
                                self.wrap_up_blob(i,j)
                                break
                            '''
                            -----------------------Here we initiate the narrow scan around the peak found in the broad scan WITH MICROWAVES-----------------------
                            '''
                            '''
                            Create a folder in which all these scans will be saved
                            '''
                            '''
                            ################################# optimize position  ###########################################
                            '''
                            success=self.single_dim_optimization(dims = ['x', 'y'] , reps=1,name='before_narrow_mw_scan')
                            success = self.z_optimization(name = 'before_narrow_mw_scan')


                            narrow_redmw_parentfolder = os.path.join(narrow_parentfolder,'REPEATED_RED_MW')
                            if not os.path.exists(narrow_redmw_parentfolder):
                                os.makedirs(narrow_redmw_parentfolder)

                            Laserscan_name = 'LaserScan_NarrowMW_peak_%d'%(peak_index)
                            ls = laser_scan.RedScan(name = Laserscan_name, save = False, h5basegroup=self.m.h5basegroup, h5datafolder = self.m.datafolder, qtdatafolder = narrow_redmw_parentfolder)
                            ls.params.from_dict(qt.exp_params['protocols']['Auto_NV_search']['Narrow_Laserscan_MW'])
                            ls.params['time']=time.time()

                            ### Checking whether the pipe var ESR_fit_result_frq, should be obtained from the params dict, or as output from the esr step. 
                            if hasattr(self.m,'ESR_fit_result_frq'):
                                ls.params['MW_freq'] = self.m.ESR_fit_result_frq

                                                        ### determining the scanning range
                            ## XXXXX move this to outside narrowmw,. thresholds to general msmt params rather than laserscan params
                            if hasattr(self.m, 'broadscan_peak_width'):
                                if self.m.broadscan_peak_width > ls.params['peak_width_threshold']:
                                    self.m.params['do_narrowmw'] = False
                                else:
                                    ls.params['narrow_freq_range'] = ls.params['below_threshold_range']
                            else:
                                ls.params['narrow_freq_range'] = ls.params['below_threshold_range']

                            print 'MW freq is set to', ls.params['MW_freq']
                            print 'Narrow MW freq range is:', ls.params['narrow_freq_range']
                            ### finding the start and stop frequencies from the peak and the narrow_freq_range.

                            ls.params['narrowscan_start_freq'] = peak - ls.params['narrow_freq_range']/2.0
                            ls.params['narrowscan_stop_freq'] = peak + ls.params['narrow_freq_range']/2.0

                            if self.m.params['do_narrowmw']:

                                filepath = TLC.initiate_scan(ls=ls, start_freq = ls.params['narrowscan_start_freq'], stop_freq = ls.params['narrowscan_stop_freq']) 
                                ls.finish()
                                self.m.h5data.flush() #flush the data in the datafile, such that it is also available if the code crashes after this.


                                '''
                                The peak is fit immediately 
                                This can be used to find the frequencies for a resonant Rabi or (D)ESR.
                                The check whether the peak is suitable for resonant excitation (i.e. if succesful) is only done if no other peak is found yet
                                This sets automatically the ideal order: highest peak first, and narrow mw scan before narrow green red scan.
                                '''
                                success_fit, peak_fit, peak_fit_err, gauss_width  = analyse_single_trans.get_freq_from_gauss(filepath[0], ret='success')

                                # if we also do a narrow green-red scan, it is preferred to get the peak from that scan. 
                                # 
                                if (not self.Redscansuccess and not self.m.params['do_narrow']):
                                    if success_fit: # check the success only if no peak has been found yet. 
                                        if peak_fit_err < self.m.params['narrowmw_peak_fit_error'] and gauss_width < self.m.params['narrowmw_peak_width']: ## 
                                            self.Redscansuccess = False #### HARDCODED THIS IN, BECAUSE 
                                            ### ON THE CURRENT SAMPLE, IN ANY CASE I WANT TO DO A GREEN RO. HAVE TO THINK HOW TO DO THIS IN A BETTER WAY...
                                            max_peak_fit = peak_fit


                                self.m.params['blob_%d_%d_peak_index_%d_narrow_scan_MW_dir'%(j,i,peak_index)] = narrow_redmw_parentfolder


                    if self.m.params['laser_type'] == 'MSquared':
                        self.msquared.set_wl(585)
                        time.sleep(3)


                    if self.m.params['shutter_ZPL']:
                        print 'Flipping ShutterZPL up'
                        shutter = qt.instruments['ShutterZPL']
                        time.sleep(2)
                        shutter.flip_up()
                        time.sleep(2)



                    ###################################### CONTINUE CONDITION ###########################################################
                    # if Redscansucces, or if we are to ignore the laserscan success for doing resonant readout, we set continue_resonant = True
                    # if this is False, we will continue_offresonant (no explicit condition). This means: doing a fine ESR with green RO. 
                    if self.Redscansuccess:
                        continue_resonant = True

                    # if (self.m.params['laser_type'] == 'MSquared'):
                    #     self.msquared.set_wl(585)
                    #     time.sleep(2)


                    # if self.m.params['shutter_ZPL']:
                    #     print 'Flipping ShutterZPL up'
                    #     #shutter = qt.instruments['ShutterZPL']
                    #     shutter.flip_up()


                ### overwrite the optical tranisition frequency if  the red scan or broad scan were successful. 
                # note that the frequency from msmt_params will be used if both were not succesful.
                if self.Redscansuccess:
                    self.m.params['optical_transition_peak'] = max_peak_fit 
                elif self.Broadscansuccess:
                    self.m.params['optical_transition_peak'] = self.m.peak_freqs[0]
                else:
                    self.m.params['optical_transition_peak'] = self.m.params['narrow_peak_freqs'][0]



                '''
########################################### E S R  - G R E E N R E D  -   C O A R S E    ###########################################
                '''
                #if we found peaks, continue to do a green-red readout ESR
                '''
                We only do a coarse ESR with green red read out if the first ESR was not succesful. 
                '''
                if ((continue_msmts and continue_resonant) and (self.m.params['do_coarse_greenred_esr'] and not self.ESRsuccess)):
                    print 40*'*'
                    print 'starting coarse green red ESR'
                    print 40*'*'
                    self.show_stopper()
                    if self.stopper:
                        self.wrap_up_blob(i,j)
                        break

                    ########################################### optimize position  ###########################################
                    success = self.single_dim_optimization(dims = ['x', 'y'] , reps=1, name = 'before_greenred_coarse_ESR')
                    success = self.z_optimization(name = 'before_greenred_coarse_ESR')


                    #filename in case of filepath=None in run function
                    name = '_ESR_greenred_coarse_'
                    '''
                    Here is where we run the ESR script, which saves its own file separately ONLY IF no filepath is specified!
                    In this case, the name will be used as the png filename. The specified directory is where the h5-file is saved.
                    This will ensure that the png image of ESR will be saved together with the h5-file that ALSO contains the ESR data,
                    since it is returned by e.run(..) and saved as a separate group in h5 (see following).
                    We here use the class GreenRed_esr_on_blob, that uses greenred readout. 
                    The parameters we load correspond to this coarse green red ESR. 

                    Before we load the measurement, we want to park the laser at the right position. 
                    We use the peak that was found in the peak search. 
                    We use the TLC for this

                    '''      

                    ### set the laser to the right frequency
                    # could consider here first checking whether it can be reached without the TLC.
                    print ['optical_transition_peak'], self.m.params['optical_transition_peak']
                    TLC.set_TLC_to_freq(self.m.params['optical_transition_peak'])

                    l = laser_scan.LaserFrequencyScan(name = 'move_to_resonance', save = False )
                    l.scan_to_frequency(self.m.params['optical_transition_peak'])
                    l.finish()

                    # check that frequency setting worked
                    ## note that we here hardcode the wavemeter channel!!
                    red_wm_channel =1
                    freq = self.physical_adwin.Get_FPar(40+red_wm_channel)
                    print 'the red laser frequency is ', freq, ';     starting coarse ESR!'
                    self.m.params['red_freq_during_redgreen_coarse_ESR'] = freq

                    ## start the REDgreen ESR
                    e2 = esr_NV_search.GreenRed_esr_on_blob(name = name, save=False,h5basegroup=self.m.h5basegroup, h5datafolder = self.m.datafolder)  #XXX make this self.e later #XXX initialize anew for each esr
                    e2.params.from_dict(qt.exp_params['protocols']['Auto_NV_search']['GreenRed_ESR'])
                    e2.params['time'] = time.time()


                    self.greenredcoarseESRsuccess, greenredcoarseESRfreq, greenredcoarseESRcounts, self.translational_correction = e2.run(translational_correction = self.translational_correction, 
                        ref_coordinates = self.ref_coors, cur_nr_esr_succes = cur_nr_esr_succes) # XXX do we need these parameters?
                    
                    self.m.ESR_fit_result_frq  = e2.ESR_fit_result_frq
                    # print 'The h5 data is saved in', self.m.datafolder #we have to be careful here to use datafolder rather than filepath, which also contains the filename!
                    # print 'The ESR images are saved in', self.m.h5data.filepath() #e.filepath should be the same as m.datafolder, unless we havent specified the filepath when creating e.run
                    e2.finish()
                    self.m.h5data.flush() #flush the data in the datafile, such that it is also available if the code crashes after this.

                    ###################################### CONTINUE CONDITION ###########################################################
                    # there is no continue condition! always continues after fine ESR.

                    self.m.params['success_greenred_coarseESR'] = self.greenredcoarseESRsuccess

                '''
########################################### E S R  - G R E E N R E D  -   F I N E    ###########################################
                '''
                '''
                We next do a fine ESR with green-red readout, but only if continue_resonant is True, 
                namely if the laserscan was succesful, or if we have set to ignore laserscansuccess in the beginning
                '''
                if ((continue_msmts and continue_resonant) and self.m.params['do_fine_greenred_esr']):
                    print 40*'*'
                    print 'starting fine green red ESR'
                    print 40*'*'
                    self.show_stopper()
                    if self.stopper:
                        self.wrap_up_blob(i,j)
                        break

                    ############### optimize position  ###########################################
                    success = self.single_dim_optimization(dims = ['x', 'y'] , reps=1, name = 'before_greenred_fine_ESR')
                    success = self.z_optimization(name = 'before_greenred_fine_ESR')

                    #filename in case of filepath=None in run function
                    name = '_ESR_greenred_fine_'
                    '''
                    Here is where we run the ESR script, which saves its own file separately ONLY IF no filepath is specified!
                    In this case, the name will be used as the png filename. The specified directory is where the h5-file is saved.
                    This will ensure that the png image of ESR will be saved together with the h5-file that ALSO contains the ESR data,
                    since it is returned by e.run(..) and saved as a separate group in h5 (see following).
                    We here use the class GreenRed_esr_on_blob, that uses greenred readout. 
                    The parameters we load correspond to this coarse green red ESR. 

                    Before we load the measurement, we want to park the laser at the right position. 
                    We use the peak that was found in the peak search. 
                    We use the TLC for this

                    '''      
                    ### set the laser to the right frequency
                    # could consider here first checking whether it can be reached without the TLC.
                    TLC.set_TLC_to_freq(self.m.params['optical_transition_peak'])

                    l = laser_scan.LaserFrequencyScan(name = 'move_to_resonance', save = False )
                    l.scan_to_frequency(self.m.params['optical_transition_peak'])
                    l.finish()

                    #### save the frequency we are at now.
                    ## note that we here hardcode the wavemeter channel!!
                    red_wm_channel =1
                    freq = self.physical_adwin.Get_FPar(40+red_wm_channel)
                    self.m.params['red_freq_during_redgreen_fine_ESR'] = freq
                    print 'the red laser frequency is ', freq, ';     starting fine ESR!'

                    #### start the REDgreen ESR
                    e2 = esr_NV_search.GreenRed_esr_on_blob(name = name, save=False,h5basegroup=self.m.h5basegroup, h5datafolder = self.m.datafolder)  #XXX make this self.e later #XXX initialize anew for each esr
                    e2.params.from_dict(qt.exp_params['protocols']['Auto_NV_search']['GreenRed_ESR_fine'])
                    e2.params['time'] = time.time()
                    if hasattr(self.m, 'ESR_fit_result_frq'): #replace the frequency if we have one from the coarse ESR
                        e2.params['center_freq'] = self.m.ESR_fit_result_frq

                    self.greenredfineESRsuccess, greenredfineESRfreq, greenredfineESRcounts, self.translational_correction = e2.run(translational_correction = self.translational_correction, 
                        ref_coordinates = self.ref_coors, cur_nr_esr_succes = cur_nr_esr_succes) # XXX do we need these parameters?

                    # print 'The h5 data is saved in', self.m.datafolder #we have to be careful here to use datafolder rather than filepath, which also contains the filename!
                    # print 'The ESR images are saved in', self.m.h5data.filepath() #e.filepath should be the same as m.datafolder, unless we havent specified the filepath when creating e.run
                    e2.finish()
                    self.m.h5data.flush() #flush the data in the datafile, such that it is also available if the code crashes after this.

                    ###################################### CONTINUE CONDITION ###########################################################
                    # there is no continue condition! always continues after fine ESR.

                    self.m.params['success_greenred_fineESR'] = self.greenredfineESRsuccess


                '''
########################################### E S R  -  F I N E -  G R E E N C W -  isotope check    ###########################################
                '''
                '''
                We next do a fine ESR with green cw readout, but only if continue_resonant is False, 
                namely if the laserscan was succesful, or if we have set to ignore laserscansuccess in the beginning
                '''                
                if (continue_msmts and self.m.params['do_fine_esr']):#and not continue_resonant in case we want to choose between fine green cw or greenred cw

                    print 40*'*'
                    print 'starting fine ESR'
                    print 40*'*'
                    self.show_stopper()
                    if self.stopper:
                        self.wrap_up_blob(i,j)
                        break

                    ########################################### optimize position  ###########################################
                    success =self.single_dim_optimization(dims = ['x', 'y'] , reps=1, name = 'before_fine_esr')
                    success = self.z_optimization(name = 'before_fine_esr')

                    ### REMOVE this line for a msmt on the optimized spot
                    ### This line is just added for a background msmt

                    mos.move_to_xyz_pos(['x', 'y', 'z'], [self.m.x_pos +2.0,self.m.y_pos + 2.0,self.m.z_pos])

                    ### REMOVE this line above

                    #filename in case of filepath=None in run function
                    name = '_ESR_fine_'+'x='+str(cur_x_pos)[:4]+'_y='+str(cur_y_pos)[:4]+'_z='+str(cur_z_pos)[:4]
                    '''
                    Here is where we run the ESR script, which saves its own file separately ONLY IF no filepath is specified!
                    In this case, the name will be used as the png filename. The specified directory is where the h5-file is saved.
                    This will ensure that the png image of ESR will be saved together with the h5-file that ALSO contains the ESR data,
                    since it is returned by e.run(..) and saved as a separate group in h5 (see following).
                    '''                 
                    ## reps was 50
                    e2 = esr_NV_search.esr_on_blob(name = name, save=False,h5basegroup=self.m.h5basegroup, h5datafolder = self.m.datafolder)  #XXX make this self.e later #XXX initialize anew for each esr
                    e2.params.from_dict(qt.exp_params['protocols']['Auto_NV_search']['ESR_fine'])
                    e2.params['time'] = time.time()

                    ### UNCOMMENT these lines below (done for a background msmt)

                    # if hasattr(self.m,'ESR_fit_result_frq'):
                    #     e2.params['center_freq'] = self.m.ESR_fit_result_frq
                    # elif self.params['use_predefined_ESR_center_freq'] == True:
                    #     e2.params['center_freq'] = self.params['predefined_ESR_center_freq'][i]

                    ### UNCOMMENT these lines above


                    self.fineESRsuccess, fineESRfreq, fineESRcounts, self.translational_correction = e2.run(translational_correction = self.translational_correction, 
                        ref_coordinates = self.ref_coors, cur_nr_esr_succes = cur_nr_esr_succes) # XXX do we need these parameters?


                    print 'The h5 data is saved in', self.m.datafolder #we have to be careful here to use datafolder rather than filepath, which also contains the filename!
                    print 'The ESR images are saved in', self.m.h5data.filepath() #e.filepath should be the same as m.datafolder, unless we havent specified the filepath when creating e.run
                    e2.finish()
                    self.m.h5data.flush() #flush the data in the datafile, such that it is also available if the code crashes after this.

                    ###################################### CONTINUE CONDITION ###########################################################
                    # there is no consinue condition! always continues after fine ESR.

                self.m.params['success_fineESR'] = self.fineESRsuccess





                """
########################################## RABI OSCILLATION  ################################################
                """

                """
                We attempt a Rabi msmt with or without resonant RO. This will return rabi = True, rabi_freq, rabi_freq_error, folder if the data is classified as a Rabi oscillation.
                Otherwise, it returns False, None, None, folder. The tolerances for this analysis are set in msmt_params. 
                A plot of the data with fit and FFT of the data with a Gaussian fit, is saved in the data folder. 
                This folder is than moved to a parent folder called ESPIN in the blob. 

                TODO::::::: when running the GreenRO class for Rabi or DESR msmt, and taking out 
                'GreenRO_Rabi' or 'GreenRO_DESR' it errors out when analysing the data. 
                Showing the error 'Can't open attribute (Can't locate attribute: 'sweep_pts')
                When we want to do resonant RO, 'GreenRO' should not be in the name of the file to avoid 
                a lot of confusion. So we have to resolve this...
                """

                # This selects the freq of the fit, whether it should come from narrow, narrowmw or the dict. 
                # Also, whether we manually set the Redscan to a success
                # This can be coded up in a better way. 
                if self.m.params['do_narrow']:
                    max_peak_fit = self.get_pipe_var(max_peak_fit, 'max_peak_fit', 'narrow', 'rabi')
                    # Redscansuccess = get_pipe_var(Redscansuccess, 'redsuccess', 'narrow', 'rabi')
                elif self.m.params['do_narrowmw']:
                    max_peak_fit = self.get_pipe_var(max_peak_fit, 'max_peak_fit', 'narrowmw', 'rabi')
                    # Redscansuccess = get_pipe_var(Redscansuccess, 'redsuccess', 'narrowmw', 'rabi')
                else:
                    max_peak_fit = self.get_pipe_var(max_peak_fit, 'max_peak_fit', 'narrow', 'rabi')
                    # Redscansuccess = get_pipe_var(Redscansuccess, 'redsuccess', 'narrow', 'rabi')
                print 'The max_peak fit is', max_peak_fit
                print 'Redscansuccess is', self.Redscansuccess

                espin_parentfolder = os.path.join(self.m.datafolder, 'ESPIN') # here we create a new directory inside autoNVsearch inside each blob folder to save all espin data

                if not os.path.exists(espin_parentfolder):
                    os.makedirs(espin_parentfolder)
                else:
                    print 'The "ESPIN" main folder could not be created.'

                if (self.m.params['do_rabi'] and self.ESRsuccess):
                    """
                    Only if ESRsuccess is True and we wish to do a Rabi we proceed to do a rabi msmt.
                    """
                    print 40*'*'
                    print 'starting RABI'
                    print 40*'*'
                    self.show_stopper()
                    if self.stopper:
                        self.wrap_up_blob(i,j)
                        break
    ########################################### PREFORMING A DRIFT CALIBRATION ############################################
    ########################################### PREFORMING A DRIFT CALIBRATION ############################################
                    if ((bool(cur_nr_esr_succes) or set_ref_manually) and self.m.params['do_translation_correction']):
                        print 'Performing translational correction...'
                        self.translational_correction = calibrate_drift.calibrate_drift([self.translational_correction[0],self.translational_correction[1],self.translational_correction[2]], \
                        self.ref_coors, printstate = printstate)
                        print 'translational_correction', self.translational_correction
    ########################################### PREFORMING A DRIFT CALIBRATION ############################################
    ########################################### PREFORMING A DRIFT CALIBRATION ############################################

                    if (self.Redscansuccess):
                        """
                        Only if Redscansuccess is true, we proceed to a Rabi msmt with resonant RO. 
                        """


                        # Moving the laser to the desired freq. (TODO: this should be implemented using the TLC, for a better range...)
                        l = laser_scan.Scan(red_labjack_dac_nr = 3)
                        l.scan_to_frequency(max_peak_fit, frequency_step_scan=self.m.params['rabi_mov_to_freq_step'])

                        ### Checking whether the pipe var ESR_fit_result_frq, should be obtained from the params dict, or as output from the ESR step.
                        ESR_fit_result_frq = self.get_pipe_var(self.m.ESR_fit_result_frq, 'MW_freq', 'esr', 'rabi')

                        rabi_success, rabi_freq, rabi_freq_error, espin_folder = r.run('Rabi', center_freq = ESR_fit_result_frq*1.0e9, do_spatial_optimize = self.m.params['rabi_optimize'],\
                        ssbmod_amplitude =self.m.params['rabi_ssbmod_first'], cycles = self.m.params['rabi_redRO_cycles'])
                    else:
                        """
                        Else we proceed to a Rabi msmt with Green RO. 
                        """
                        ESR_fit_result_frq = self.get_pipe_var(self.m.ESR_fit_result_frq, 'MW_freq', 'esr', 'rabi')

                        rabi_success, rabi_freq, rabi_freq_error, espin_folder = r.run('Rabi', center_freq = ESR_fit_result_frq*1.0e9, do_spatial_optimize = self.m.params['rabi_optimize'],\
                        ssbmod_amplitude =self.m.params['rabi_ssbmod_first'], cycles = self.m.params['rabi_GreenRO_cycles'], readout_type = 'off_resonance')

                    # Moving the measurement to the espin parent folder in a file name 'RABI'
                    newespindir = os.path.join(espin_parentfolder, os.path.basename(espin_folder))
                    newespinfoldername = os.path.join(espin_parentfolder, 'RABI')

                    try:
                        shutil.move(espin_folder, espin_parentfolder)
                    except WindowsError:
                        pass

                    try:
                        os.rename(newespindir, newespinfoldername)
                    except WindowsError:
                        pass
                    """
########################################## DESR ################################################
                    """
                if (self.m.params['do_desr'] and rabi_success and self.ESRsuccess):
                    if (self.Redscansuccess):
                        """
                        Only if Redscansuccess is true, we proceed to a desr msmt with resonant RO. 
                        """

                        # Moving the laser to the desired freq. (TODO: this should be implemented using the TLC, for a better range...)
                        l = laser_scan.Scan(red_labjack_dac_nr = 3)
                        l.scan_to_frequency(max_peak_fit, frequency_step_scan=self.m.params['rabi_mov_to_freq_step'])

                        ### Checking whether the pipe var ESR_fit_result_frq, should be obtained from the params dict, or as output from the ESR step.
                        ESR_fit_result_frq = self.get_pipe_var(self.m.ESR_fit_result_frq, 'MW_freq', 'esr', 'desr')

                        ### Checking whether the pipe var rabi_freq, should be obtained from the params dict, or as output from the rabi step.
                        rabi_freq = self.get_pipe_var(rabi_freq, 'rabi_freq', 'rabi', 'desr')

                        d.desr_mw_pwr_estimate_simple(rabi_freq, ESR_fit_result_frq , 'resonance_RO', self.m.params['desr_optimize'], espin_parentfolder, self.m.params['desr_redRO_cycles'])
                    else:
                        """
                        Else we proceed to a desr msmt with Green RO. 
                        """
                        ### Checking whether the pipe var ESR_fit_result_frq, should be obtained from the params dict, or as output from the ESR step.
                        ESR_fit_result_frq = self.get_pipe_var(self.m.ESR_fit_result_frq, 'MW_freq', 'esr', 'desr')

                        ### Checking whether the pipe var rabi_freq, should be obtained from the params dict, or as output from the rabi step.
                        rabi_freq = self.get_pipe_var(rabi_freq, 'rabi_freq', 'rabi', 'desr')

                        d.desr_mw_pwr_estimate_simple(rabi_freq, ESR_fit_result_frq , 'off_resonance', self.m.params['desr_optimize'], espin_parentfolder, self.m.params['desr_GreenRO_cycles'])

                if (self.m.params['do_desr'] and not rabi_success and self.ESRsuccess):
                    """
                    Here I am doing a blind desr sequence
                    """
                    ### Checking whether the pipe var ESR_fit_result_frq, should be obtained from the params dict, or as output from the ESR step.
                    ESR_fit_result_frq = self.get_pipe_var(self.m.ESR_fit_result_frq, 'MW_freq', 'esr', 'desr')


                    desr_folder = d.run('DESR', center_freq = ESR_fit_result_frq*1.0e9, do_spatial_optimize = self.m.params['desr_optimize'], ssbmod_amplitude = self.m.params['rabi_ssbmod_first'],\
                    cycles = self.m.params['desr_cycles_blind'], readout_type = 'off_resonance', MW_pulse_duration = self.m.params['rabi_pi_des']*1.0e6)
                    newdesrdir = os.path.join(espin_parentfolder, os.path.basename(desr_folder))
                    newdesrfoldername = os.path.join(espin_parentfolder, 'DESR2')

                    try:
                        shutil.move(desr_folder, espin_parentfolder)
                    except WindowsError:
                        pass

                    try:
                        os.rename(newdesrdir, newdesrfoldername)
                    except WindowsError:
                        pass



                '''
########################################### W R A P P I N G  U P ###########################################
                '''
                '''
                This has to be a separate function, to enable breaking out of the loop. 
                In the wrap-up phase the successes of this blob are appended to succes-arrays
                The blob - measurement is finished such that all params are saves
                '''
                self.wrap_up_blob(i,j)

            '''
############################################### W R A P - U P   Z - P L A N E ##############################################################
            '''

            '''
            had to move this to a separate function to allow for breaking out of the loop
            '''
            self.wrap_up_z_plane(j)


        # try:
        #     message = 'AutoNVsearch completed. On behalf of our system developers, we wish you a pleasant day.'
        #     p.pushMessage("autoNVsearch", message)

        # except:
        #     pass


        # ###MR temporary for bleaching at then end of the msmt
        # for i in range(5):
        #     print i
        #     autoNVsearch_functions.zoom([-10,10.0], [-10,10], 4.2, pixeltime = 100, green_power=130e-6)

        return esr_to_check_coordinates, self.nv_coordinates


    def manage_scans(self):
#       x_o=0
#       y_o=0
#       search_range=2

        #set scan range
        x_scan = self.params['x_scan'] 
        y_scan = self.params['y_scan'] 
        z_scan = self.params['z_scan'] 

        # try:
        #     message = 'AutoNVsearch initialised, scanning depths: ' + str(z_scan)
        #     p.pushMessage("autoNVsearch", message)

        # except:
        #     pass

        esr_coordinates = []
        #iterate through the lenght of the zcans (different planes in z)
        for i in range(len(z_scan)):
            #This initiates the real scan with the set scan range

            timestamp2D, folder2D = autoNVsearch_functions.zoom(x_scan,y_scan,z_scan[i], pixeltime=10, green_power=self.params['green_scan_power'])
            qt.msleep(1)

            #retreives the timestampt and folder of the latest scan (the one perfromed in the previous line)
            #timestamp,folder = tb.latest_data(contains='scan2d', older_than = None,return_timestamp=True)
            print 'DEPTH:', z_scan[i]
            print '2D SCAN TIMESTAMP:', timestamp2D
            print '2D SCAN FOLDER:', folder2D

            #
            d = ds.DisplayScanFlim(folder2D)
            #where exactlyl is data being used?
            d.get_data()
            d.plot_data(folder2D,save=True,colormap='gist_earth',fignumber=1) 
            #saves the coordinates of the x number of mouseclicks on the plot
            print 'Please identify and click (left mouseclick) on NV candidates in the image. Right mouseclick to finish, middle mouseclick to remove the last datapoint.'
            plt.gca()
            coordinates = plt.ginput(n=-1, timeout=0, mouse_stop=3, mouse_pop=2)
            plt.close(1)

            d.finish()
            qt.msleep(0.1)

            #Since we cannot choose the directory of the 2dscan data folders, we change the name and put it inside the parent folder "autoNVsearch"
            # actually we can, please check: D:\measuring\analysis\scripts\Fabrication\Display_scan2d.py
            newdir = os.path.join(self.datafolder, os.path.basename(folder2D))
            newfoldername = 'Z_depth_%d'%z_scan[i]
            newdirnewfoldername = os.path.join(self.datafolder, newfoldername)

            try:
                shutil.move(folder2D, self.datafolder)
                os.rename(newdir, newdirnewfoldername)
            except WindowsError:
                pass
            
            
            blob_coordinates = []

            #fill in coords with the acquired mouse click coordinates
            for j in range(len(coordinates)):
                coords = []
                coords.append(coordinates[j][0])
                coords.append(coordinates[j][1])
                coords.append(z_scan[i])
                blob_coordinates.append(coords)

            esr_coordinates.append(blob_coordinates)

        print esr_coordinates
        '''
        Here we call the master function that goes through all the steps of the automated NV search: x,y opt, z opt, ESR and linescan
        '''
        esr_to_check_coordinates, nv_coordinates = self.execute_characterisation(esr_coordinates, printstate=True)
        
        print esr_to_check_coordinates, nv_coordinates #containing x, y and z values



#       esr_check_coordinates=[]
#       full_esr_to_check_coordinates=[]
#       nv_coordinates=[]
#       full_nv_coordinates=[]
#       for k,z in enumerate(z_range):

# ######### Make scan_area to be compatible with new version of blob_list!!!!
#           self.blobs_list,blobs_counter=self.scan_area(z,search_range, x_scan,y_scan)
#           print 'Number of blobs', blobs_counter
#           blobs={}
#           for i,xy in enumerate(self.blobs_list):
#               blobs['%d'%i]['x']=xy[0]
#               blobs['%d'%i]['y']=xy[1]

######## Make esr compatible with new version of blob_list!!!!
            # esr_to_check_coordinates,nv_coordinates=self.optimize_blobs_position(self.blobs_list,z)
            # #print esr_check_coordinates
            # full_esr_to_check_coordinates.append(esr_to_check_coordinates)
            # full_nv_coordinates.append(nv_coordinates)


            # print 'full_esr_to_check_coordinates', full_esr_to_check_coordinates
            # print 'full_nv_coordinates', full_nv_coordinates
            


            # cv2.waitKey(0)
                
        #Give it array of x and y blob coordinates

        #Do a confocal scan around these coordinates with a certain width, itegration time, green power, ...






def start_scan():
    m = NV_search(name='autoNVsearch')
    # m.params['x_scan'] = [0.,10.]#[0,10]
    # m.params['y_scan'] = [0.,10.]#[-10,0]
    # m.params['z_scan'] = [-572.1]#[2.83]#, -1.0, -3.0, -5.0, -7.0, -9.0]

    #m.params['x_scan'] = [-75., -65.]#[0,10]
    #m.params['y_scan'] = [-471., -461.]#[-10,0]
    #m.params['z_scan'] = [-379.93]#
    m.params['x_scan'] = [-570,-550]#[0,10]
    m.params['y_scan'] = [500,520]#[-10,0]
    m.params['z_scan'] = [732.36]

    m.manage_scans() #containing x, y and z values
    m.finish()


def start_scan_debug():
    m = NV_search(name='autoNVsearch')



    coordinates = [[[-167.61,16.63,-604.43]]]
    esr_to_check_coordinates,nv_coordinates = m.execute_characterisation(coordinates, printstate= False)

    m.finish()

    # # I=nir.CNN()
    # # I.train(r'D:\measuring\data\20180210\data\train',saved_file='trained_explorer_68',folder_validate=r'D:\measuring\data\20180210\data\validate')
    # # folder_name=r'D:\measuring\data\20180211\130859_scan2d\images_to analyze\to_test' 
    # # I.load_trained_model(load_file='trained_explorer_68')
    # # I.analyze_images_from_folder(folder_name)
    # # # e=esr_NV_search.esr_on_blob()
    # # success=e.run(name='test_esr')
    # # print success

def test_peak_finder():
    m = NV_search(name = 'test_peak_finder',save=False)
    m.params.from_dict(qt.exp_params['protocols']['Auto_NV_search'])

    folder = r'D:\measuring\data\20180903\214804_Measurement_blob_0_0_x_5.81_y_-0.67_z_3.00/BROAD_RED_SCANS'
    #folder = r'D:\measuring\data\20180903\190558_Measurement_blob_0_0_x_6.14_y_-0.40_z_3.00\BROAD_RED_SCANS'
    filepaths = os.listdir(folder)
    print filepaths

    redfreq=[]
    redcounts=[]
    for M in filepaths: 
        if M[-4:] =='.dat':
            print M
            reddata = np.loadtxt(os.path.join(folder,M)) # reads one of the linescan files                        
            redfreq.extend(reddata[:,1]) # adds a new list of frequencies to the existing array
            redcounts.extend(reddata[:,2]) # adds a new list of counts to the existing

    # bin the data
    m.params['Broad_Laserscan']['binsize_postprocessing'] = 0.2

    m.params['broadscan_noisefloor_factor'] =7
    nr_bins = int((max(redfreq)-min(redfreq))/m.params['Broad_Laserscan']['binsize_postprocessing'])+1 #this is necessary, because in practice the steps are not freq_step.
    bins = np.linspace(min(redfreq),max(redfreq),nr_bins)
    _h_points,_b_points, = np.histogram(redfreq, weights=np.ones(len(redfreq)), bins=bins) #histogram for normalisation
    _h,_b = np.histogram(redfreq, weights=redcounts, bins=bins) #histogram that adds up the counts per bin
    binned_redfreq=_b[:-1]+np.diff(_b) #freqpoints should be the centre of the bin
    binned_redcounts = _h/_h_points #we have to normalise again to get the appropriate rate!
    # remove bins where there were no points inside (they turned out as 'nan' counts)
    binned_redfreq = binned_redfreq[~np.isnan(binned_redcounts)]
    binned_redcounts = binned_redcounts[~np.isnan(binned_redcounts)]

    print np.mean(redcounts)
    print np.mean(binned_redcounts)

    m.find_peaks(binned_redfreq, binned_redcounts)

    # # d= ds.DisplayScanFlim(folder)
    # # d.get_data()
    # # d.split_image(folder,x_scan,y_scan,save=True,colormap='gist_earth',search_range=search_range)

    # #filter_str=['x_c=-1 y_c=-3 ','x_c=-1 y_c=-10', 'x_c=-2 y_c=-1 ']
    # filter_str=['x_c']
    # qt.instruments['GreenAOM'].turn_on()

    # for filename in os.listdir(folder):
    #     if any(s in filename for s in filter_str):
    #         if not ('search_range' or '.hdf5' or'earth') in filename:

    #             print folder
    #             print filename

                
                
    #             cropped_image=ip.crop_image(folder, filename)
    #             x_blobs,y_blobs=ip.find_blobs(folder,filename,cropped_image,search_range,z)
                
    #             xs_blobs = np.append(xs_blobs,x_blobs)
    #             ys_blobs= np.append(ys_blobs,y_blobs)

                
    #             #xy_blobs=np.append([x_blobs],[y_blobs],axis=0)
                
                
    #             #xy_blobs=np.transpose(xy_blobs)
    
    # self.blobs_list=np.append([xs_blobs],[ys_blobs],axis=0)
    
    # print 'number of blobs',len(xs_blobs)

    # del filter_str


    # name='outcome_cordinates'
    # dat = h5.HDF5Data(name=name)
    # dat.create_dataset('z='+str(z)+' blobs_coordinates', data=np.transpose(self.blobs_list))
    # m2.save_instrument_settings_file(dat)
    # dat.close()
    
    # # d = qt.Data(name=name)
    # # d.add_coordinate('x')
    # # d.add_value('y')
    # # d.create_file()
    # # d.add_data_point(blobs_counter[0][1], blobs_counter[0][1])
    # # d.close_file()
                
    # # esr_check_coordinates,nv_coordinates=S.optimize_blobs_position(self.blobs_list,z)
    # # print 'esr_to_check', esr_check_coordinates
    # # print 'nv_coordinates', nv_coordinates



    # #cv2.imshow('img',img)


if __name__ == '__main__':
    # test_peak_finder()  
    debug=False
    bleaching = False

    if bleaching:   
        m = NV_search(name = 'bleaching')
        for i in range(1):
            print i
            autoNVsearch_functions.zoom([-8,4.0], [-2,12], 2.8, pixeltime = 100, green_power=135e-6)
    else:

        if debug:
            for i in range(1):
                start_scan_debug()

        else:
            start_scan()



    #   for i,x_c in enumerate(x_range):
            
    #       img_buf_vertical=[]
            
    #       for j,y_c in enumerate(y_range):
    #           self.zoom(i,j,x_0=x_c, y_0=y_c, z_plane=z, area_size=search_range)
    #           timestamp2,folder = tb.latest_data(contains='scan2d', older_than = None,return_timestamp=True)
    #           d= ds.DisplayScanFlim(folder)
    #           d.get_data()
    #           d.plot_data(folder,save=True,colormap='gist_earth')             

    #           ip.config(scan_size=search_range)
    #           cropped_image=ip.crop_image(folder)
    #           x_blobs,y_blobs,img=ip.find_blobs(folder,cropped_image,zoom,x_c,y_c,z)
    #           xy_blobs=np.append([x_blobs],[y_blobs],axis=0)
    #           xy_blobs=np.transpose(xy_blobs)
    #           self.blobs_list.append(xy_blobs)
    #           img_buf_vertical.append(img)                    
    #       img_vertical_single_row=img_buf_vertical[0]
            
    #       for q in xrange(1,len(img_buf_vertical)):
    #           img_vertical_single_row=np.concatenate((img_buf_vertical[q],img_vertical_single_row),axis=0)

    #       img_buf_total.append(img_vertical_single_row)
        
    #   img_total=img_buf_total[0]
    #   for q in xrange(1,len(img_buf_total)):
    #       img_total=np.concatenate((img_total,img_buf_total[q]),axis=1)
        

    #   cv2.imshow('total',img_total)
    #   save_folder=folder+'_Total_scan'
    # #print save_folder
    #   os.makedirs(save_folder)
    #   fig_name='z='+str(z)+'x_c='+str(x_c)+'y_c='+str(y_c)+' Area='+str(zoom)+' um.png'

    #   cv2.imwrite(os.path.join(save_folder,fig_name),img_total)

        #return self.blobs_list

'''
SUGGESTIONS FOR CONTROL PARAMETERS
- 2d scan resolution
- ESR number of iterations
- RED scan full range
- 

''' 